#!/usr/bin/python
#
# Developed by:
#       Hok Kakada (hokkakada@khmeros.info)
#       Keo Sophon (keosophon@khmeros.info)
#       San Titvirak (titvirak@khmeros.info)
#       Seth Chanratha (sethchanratha@khmeros.info)
#
# create an executable file on Windows
# command: python create-exe.py
# Requirements: distutils package and py2exe installer, sip

from py2exe.build_exe import py2exe
from distutils.core import setup
import sys, glob, os
sys.argv.append("py2exe")

print "sys pre", sys.prefix

opts = {
    "py2exe": {
        "includes": "lxml, sip",
    }
}

def files(folder):
    for path in glob.glob(folder+'/*'):
        if os.path.isfile(path):
            yield path
            
data_files=[
    ('Lib/site-packages/WordForge/Editor/images', files('Editor/images')),
    ('Lib/site-packages/WordForge/Editor/dict', files('Editor/dict')),
    ('Lib/site-packages/WordForge/hunspell-1.2.8', files('hunspell-1.2.8')),
    ('Lib/site-packages/WordForge/Editor/ui', ''),
    ]

setup(
    options = opts,
    data_files=data_files,
    windows = [
        {
            "script": "wordforge.py",
            "icon_resources": [(1, "wordforge.ico")]
        }
    ],

    console = [{"script": "wordforge.py"}],
    packages = [],
)

