from WordForge.translate.storage import factory
from WordForge.translate.storage import xliff
from lxml import etree

def cleanXliff(inputFile,  outputFile,  cleanGlossary=False,  cleanTM=False,  cleanReference = False):
    """
    remove reference, internal glossary, alt-trans from
    @param aFile: path of a file
    """
    tree= etree.parse(inputFile)
    root = tree.getroot()
    fileNode = root[0]
    # If there is a header in the file, do not create one (we use rfind because the name of the tag
    # might include also the namespace). If there is no glossary tag in the header, create one
    # if there is no internal-file tag in the glossary, create one. 
    # If there is an XLIFF glossary already in the file (XLIFF tag inside internal-file, clear it (delete it)
    # because it will be later replace by the new one.
    
#    hasHeader is a flag that is True is the file has a header , otherwise it is False
    hasHeader = False
    
    if (fileNode[0].tag.rfind("header") != -1):     # if there is a header
        hasHeader = True
        
    if cleanGlossary:
        if hasHeader: 
            header = fileNode[0]
            glossaryNode = None
            for aHeaderEntry in header:
                if (aHeaderEntry.tag.rfind("glossary") != -1):
                    glossaryNode = aHeaderEntry
            if (glossaryNode != None):
                glossaryNode.clear()
                header.remove(glossaryNode)
      
#    Take the first child under file tag if no header, if there is a header then take the second child to get the body tag.
    bodyNode = None
    if hasHeader:
        bodyNode = fileNode[1]
    else:
        bodyNode = fileNode[0]
        
    if (bodyNode.tag.rfind("body")!=-1):
        body = bodyNode
    for aBodyEntry in body:
        if (aBodyEntry.tag.rfind("trans-unit") != -1):
            transUnit = aBodyEntry
            for aUnitEntry in transUnit:
                if (aUnitEntry.tag.rfind("alt-trans") != -1):
                    altTransNode = aUnitEntry
                    thisNodeType = altTransNode.get("alttranstype")
                    if ((thisNodeType == "proposal") and cleanTM):
                        altTransNode.clear()
                        transUnit.remove(altTransNode)
                    elif ((thisNodeType == "reference") and cleanReference):
                        altTransNode.clear()
                        transUnit.remove(altTransNode)
                    elif ((thisNodeType != "proposal") and (thisNodeType != "reference")):
                        altTransNode.clear()
                        transUnit.remove(altTransNode)
#                        if (altTransNode != None):
#                        altTransNode.clear()
#                        transUnit.remove(altTransNode)

    fout = open(outputFile, 'wb')
    fout.writelines(etree.tostring(tree, pretty_print=True, xml_declaration=True, encoding='utf-8'))
    fout.close()
    
