#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Copyright 2005, 2006 Zuza Software Foundation
# Copyright 2009 WordForge Foundation
# This file is part of WordForge Editor
#
# WordForge Editor is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# WordForge Editor is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with translate; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

"""convert from internal glossary to a TBX file"""


from WordForge.translate.storage import tbx
from WordForge.translate.storage import lisa
from lxml import etree
import os

# class gl2tbx:
def convertGL2tbx(aMatcher, targetFile, sourcelanguage="en",  targetlanguage = "xx"  ):
    """converts internal Glossary (a matcher)  to a TBX file"""
    myTBX = tbx.tbxfile()
    
    for inunit in aMatcher.candidates.units:
        source = inunit.source
        target = inunit.target
        tbxunit = myTBX.addsourceunit(source)
        tbxunit.target = target
        
        # target language
        sourceLangNode = tbxunit.getlanguageNode(index = 0)
        if (sourceLangNode is not None):
#            sourceLangNode.set("{%s}lang" % XML_NS, sourcelanguage)
            lisa.setXMLlang(sourceLangNode, sourcelanguage)
        
        # target language
        targetLangNode = tbxunit.getlanguageNode(index = 1)
        if (targetLangNode is not None):
            lisa.setXMLlang(targetLangNode, targetlanguage)
#            targetLangNode.set("xml:lang", targetlanguage)
        
    fout = open(targetFile, "wb")
    fout.write(str(myTBX))
    fout.close()
