#!/usr/bin/python
# -*- coding: utf-8 -*-

#Copyright (c) 2006 - 2007 by The WordForge Foundation
#                       www.wordforgefoundation.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# See the LICENSE file for more details. 
#
# Developed by:
#       Hok Kakada (hokkakada@khmeros.info)
#       Keo Sophon (keosophon@khmeros.info)
#       San Titvirak (titvirak@khmeros.info)
#       Seth Chanratha (sethchanratha@khmeros.info)
#       Aditi Barua(aditi@ankur.org.bd)
#       Asheq Hamid(asheq@ankur.org.bd)
#       Md. Rezwan Shahid(rezwan@ankur.org.bd)
# 
# This module is working on Preferences

#if some new error tests will be added or removed , then the function  setAddNewLang, set_error_options_list, set_error_node_list, add_test, loadGlobalPreferenceValue, set_value will have to be changed.

import WordForge.Editor.modules.World as World
from WordForge.translate.lang import common
from PyQt4 import QtCore,QtGui,QtXml
from WordForge.Editor.modules.globalClass import globalClass
from WordForge.translate.storage import factory
from collections import defaultdict
import os, sys, platform
import enchant, re
from lxml import etree
import WordForge.Editor.ui.images_rc

if (os.name == 'posix') :
    localpath = os.path.split(os.path.realpath( __file__ ))[0] +os.path.sep
else:
    localpath = ""
#homePath = os.path.join(os.path.expanduser("~"), World.logDir, 'test_files' + os.path.sep)
homePath = os.path.join(World.configDir, 'test_files' + os.path.sep)

debug = World.WF_debug
class Preference(QtGui.QDialog):
    
#    xmlfile = QtCore.QFile( "../test_files/test.xml" )
    a=None

    def __init__(self, parent):
        QtGui.QDialog.__init__(self, parent)
        self.ui = None
        self.parent = parent
        self.__activeDictionary__ = ''
        singleQuot=False
        self.singleQuot=singleQuot
        pressNewLang=False
        self.pressNewLang= pressNewLang
        self.element=None
        self.MoreLanguageFlag=0
        self.language=''
        self.country=''
        self.iso3List = []
        self.fileswithnolanguage=[]
        self.fileswithdifflanguage=[]
        self.thesfilenames=[]
        self.chkwordpros =True
        self.personallevelString=''
    def initUI(self):
        """ get values and display them """
        self.__overViewFont__ = self.getFont(self.widget[0])
        self.setCaption(self.ui.lblOverView, self.__overViewFont__)
        self.__tuSourceFont__ = self.getFont(self.widget[1])
        self.setCaption(self.ui.lblSource, self.__tuSourceFont__)
        self.__tuTargetFont__ = self.getFont(self.widget[2])
        self.setCaption(self.ui.lblTarget, self.__tuTargetFont__ )
        self.__commentFont__ = self.getFont(self.widget[3])
        self.setCaption(self.ui.lblComment, self.__commentFont__)
        self.overviewHeaderFont = self.getFont(self.widget[4])
        self.setCaption(self.ui.lblOverViewHeader, self.overviewHeaderFont)
        self.__TMFont__ = self.getFont(self.widget[5])
        self.setCaption(self.ui.lblTM, self.__TMFont__)
        self.__glossaryFont__ = self.getFont(self.widget[6])
        self.setCaption(self.ui.lblGlossary, self.__glossaryFont__)
        
        self.__overviewColorObj__ = self.getColor(self.widget[0])
        self.setTextColor(self.ui.lblOverView, self.__overviewColorObj__)
        self.__tuSourceColorObj__ = self.getColor(self.widget[1])
        self.setTextColor(self.ui.lblSource, self.__tuSourceColorObj__)
        self.__tuTargetColorObj__ = self.getColor(self.widget[2])
        self.setTextColor(self.ui.lblTarget, self.__tuTargetColorObj__)
        self.__commentColorObj__ = self.getColor(self.widget[3])
        self.setTextColor(self.ui.lblComment, self.__commentColorObj__)
        self.__TMColorObj__ = self.getColor(self.widget[5])
        self.setTextColor(self.ui.lblTM, self.__TMColorObj__)
        self.__glossaryColorObj__ = self.getColor(self.widget[6])
        self.setTextColor(self.ui.lblGlossary, self.__glossaryColorObj__)
        
        self.ui.UserName.setText(World.settings.value("UserName").toString())
        self.ui.EmailAddress.setText(World.settings.value("EmailAddress").toString())
#        self.ui.lineFullLang.setText(World.settings.value("FullLanguage").toString())
#        self.ui.cbxLanguageCode.setEditText(World.settings.value("Code").toString())
#        LanguageCode=World.settings.value("Code",  QtCore.QVariant("18")).toInt()[0]
#        self.ui.cbxLanguageCode.setCurrentIndex(LanguageCode)
        countryCode=World.settings.value("CountryCode",  QtCore.QVariant("18")).toInt()[0]
        self.ui.cbxCountryCode.setCurrentIndex(countryCode)
        self.ui.SupportTeam.setText(World.settings.value("SupportTeam").toString())
        self.ui.spinBox.setValue(World.settings.value("nPlural").toInt()[0])
        self.ui.lineEqaution.setText(World.settings.value("equation").toString())
        
        # Set disabled spinBox in save icon of ui
        autoSave = World.settings.value("EnableAutoSave", QtCore.QVariant(True)).toBool()
        self.ui.QSpinBoxAutoSave.setValue(World.settings.value("autoSaveInterval", QtCore.QVariant("5")).toInt()[0])
        self.ui.chkshowwanring.setChecked(World.settings.value("warningLangMismatch",  QtCore.QVariant(True)).toBool())
        self.ui.checkBox.setChecked(autoSave)
        self.ui.QSpinBoxAutoSave.setEnabled(autoSave)
       
        
        self.setState(self.ui.chkHeaderAuto, "headerAuto")
        self.setState(self.ui.chkCursorHome, "AcceleratorList")
        
        # Read TM configuration from WordForge.ini if TM Settings have been stored
        # Otherwise define default value.

        self.ui.chkTargetInclusion.setChecked(World.settings.value("TM_TargetInclusion",  QtCore.QVariant(False)).toBool())
        self.ui.chkGLb4TM.setChecked(World.settings.value("TM_GLb4TM",  QtCore.QVariant(True)).toBool())
        self.ui.FuzzyGLb4TM.setChecked(World.settings.value("FuzzyGLb4TM",  QtCore.QVariant(False)).toBool())
#        self.ui.chbMarkStringAsFuzzy.setChecked(World.settings.value("TM_MarkStringAsFuzzy",  QtCore.QVariant(False)).toBool())
        self.ui.chbMarkStringAsFuzzy.setEnabled(World.settings.value("TM_TargetInclusion",  QtCore.QVariant(False)).toBool())
        self.ui.chkAddSuggestions.setChecked(World.settings.value("TM_AddSuggestions",  QtCore.QVariant(True)).toBool())
        self.ui.chkEliminateIdentical.setChecked(World.settings.value("TM_EliminateIdentical",  QtCore.QVariant(True)).toBool())
        self.ui.chkIncludeFuzzy.setChecked(World.settings.value("TM_IncludeFuzzy",  QtCore.QVariant(False)).toBool())
        self.ui.chkInstant.setChecked(World.settings.value("TM_Instant",  QtCore.QVariant(False)).toBool())
        
        self.ui.spnTarget.setValue(World.settings.value("TM_max",  QtCore.QVariant("100")).toInt()[0])
        self.ui.spnMin.setValue(World.settings.value("TM_min",  QtCore.QVariant("70")).toInt()[0])
        self.ui.spnMaxSuggestions.setValue(World.settings.value("TM_max_candidates",  QtCore.QVariant("10")).toInt()[0])
        self.ui.spnMaxLen.setValue(World.settings.value("TM_max_string_len",  QtCore.QVariant("200")).toInt()[0])
        self.detectMarkFuzzyStatus()
        self.ui.thessourcelang.setCurrentIndex(World.settings.value("sourcelanguage",  QtCore.QVariant("37")).toInt()[0])
        self.ui.thessourceCoun.setCurrentIndex(World.settings.value("sourcecountry",  QtCore.QVariant("232")).toInt()[0])
        
        #read from init file if the glossary should be used or not, defaul to True if no any file
        # value is exported to user interface
        GlossaryPreference = World.settings.value("GlossaryPreference", QtCore.QVariant(True)).toBool()
        self.ui.chbAutoIdentTerm.setChecked(GlossaryPreference)
        #I have commented the following line to make error checking options message box working correctly.
#        self.connect(self.ui.okButton, QtCore.SIGNAL("clicked()"), self.accept)

        self.connect(self.ui.cancelButton, QtCore.SIGNAL("clicked()"), self.reject)
        
        #invisible characters
        enableWordpros= World.settings.value("invisiblecharacater", QtCore.QVariant(True)).toBool()
        if enableWordpros:
            self.ui.chkwordpros.setChecked(True)
            self.ui.chkscaping.setChecked(False)
        else:
            self.ui.chkwordpros.setChecked(False)
            self.ui.chkscaping.setChecked(True)
            
        # dictionary language
        self.ui.tableSpellCheck.setColumnCount(3)
        self.ui.tableSpellCheck.horizontalHeader().setResizeMode(1, QtGui.QHeaderView.Stretch)
        self.ui.tableSpellCheck.setHorizontalHeaderLabels([self.tr("Active"), self.tr("Language Names"), self.tr("Dictionaries")])
        self.ui.tableSpellCheck.horizontalHeader().setSortIndicatorShown(True)
        self.ui.tableSpellCheck.verticalHeader().hide()
        
        #dictionary language
        self.ui.tableThesaurus.setColumnCount(4)
        self.ui.tableThesaurus.horizontalHeader().setResizeMode(0, QtGui.QHeaderView.Interactive)
        self.ui.tableThesaurus.horizontalHeader().setResizeMode(1, QtGui.QHeaderView.Interactive)
        self.ui.tableThesaurus.horizontalHeader().setResizeMode(2, QtGui.QHeaderView.Interactive)
        self.ui.tableThesaurus.horizontalHeader().setDefaultSectionSize(200)
        self.ui.tableThesaurus.setHorizontalHeaderLabels([self.tr("Active Thesaurus For Source"), self.tr("Active Thesaurus For Target"), self.tr("Language Names"), self.tr("Thesauruses")])
        self.ui.tableThesaurus.horizontalHeader().setSortIndicatorShown(True)
        self.ui.tableThesaurus.verticalHeader().hide()
        
        spellCheckIgnoreSource = World.settings.value("notHighlightInSource", QtCore.QVariant(True)).toBool()
        self.ui.chkSpellIgnoreSource.setChecked(spellCheckIgnoreSource)
#        self.ui.chbAutoAddAltsTran.setChecked(World.settings.value("AutoAddAltsTran").toBool())

#code starts for error checking

        enableVariable = World.settings.value("enableVariable", QtCore.QVariant(True)).toBool()
        enableAccelerator = World.settings.value("enableAccelerator", QtCore.QVariant(True)).toBool()
        
        enableGlossary = World.settings.value("enableGlossary", QtCore.QVariant(True)).toBool()
        self.ui.leGeneral.setEnabled(enableGlossary)
        self.ui.leNones.setEnabled(enableGlossary)
        self.ui.leVerbs.setEnabled(enableGlossary)
        self.ui.leAdjectives.setEnabled(enableGlossary)
        
        enablePunctuation = World.settings.value("enablePunctuation", QtCore.QVariant(True)).toBool()
        self.ui.chkVariable.setChecked(enableVariable)
        self.ui.cbxVariable.setEnabled(enableVariable)
        
        self.ui.chkAccelerator.setChecked(enableAccelerator)
        self.ui.cbxAccelerator.setEnabled(enableAccelerator)
        self.ui.leAccelerator.setEnabled(enableAccelerator)
        self.ui.leAccelerator.setText("~")
        
        self.ui.leFullStop.setEnabled(enablePunctuation)
        self.ui.leQuestionMark.setEnabled(enablePunctuation)
        self.ui.leExcla.setEnabled(enablePunctuation)
        self.ui.leSemiColon.setEnabled(enablePunctuation)
        self.ui.leColon.setEnabled(enablePunctuation)
        self.ui.leElipsis.setEnabled(enablePunctuation)
        self.ui.leComma.setEnabled(enablePunctuation)
        
        self.ui.cbxLanguage.setEditable(False)
        currentIndex=0
#        currentindex=World.settings.value(("currentCountry").toString(), QtCore.QVariant("0")).toInt()[0]
        currentindex=World.settings.value("currentCountry",  QtCore.QVariant("18")).toInt()[0]
#        currentindex=int(currentindex)
        self.ui.cbxCountry.setCurrentIndex(currentindex)
        currentIndex=0
        currentindex=World.settings.value("ErrorcurrentLanguage",  QtCore.QVariant("Bengali [bn]")).toString()
        j=-1
        for i in self.List:
            j=j+1
            if(i==currentindex):
                break
        self.ui.cbxLanguage.setCurrentIndex(j)
        
        currentindex=World.settings.value("FullLanguage",  QtCore.QVariant("Bengali [bn]")).toString()
        j=-1
        for i in self.List:
            j=j+1
            if(i==currentindex):
                break
        self.ui.cbxLanguageCode.setCurrentIndex(j)
        self.loadActiveLanguageCountry()
        
    def detectMarkFuzzyStatus(self):
        """
        detect and set MarkAsFuzzy checkbox
        """   
        if( World.settings.value("TM_TargetInclusion").toBool() ):
            self.ui.chbMarkStringAsFuzzy.setChecked(World.settings.value("TM_MarkStringAsFuzzy",  QtCore.QVariant(False)).toBool())
        else:
            self.ui.chbMarkStringAsFuzzy.setChecked(False)
            
    def setState(self, obj, value):
        """
        set checked or unchecked to the obj.
        """
        state = World.settings.value(value, QtCore.QVariant(True))
        if (state.toBool()):
            obj.setCheckState(QtCore.Qt.Checked)
        else:
            obj.setCheckState(QtCore.Qt.Unchecked)
    #start of error checking codes by Aditi
            
    def setAddNewLang(self):
        #default setting for the options
        self.pressNewLang=True
    
        self.ui.chkEmail.setChecked(False)
        self.ui.chkUrl.setChecked(False)
        self.ui.chkFunction.setChecked(False)
        self.ui.chkFilePath.setChecked(False)
        self.ui.chkNewLine.setChecked(False)
        self.ui.chkPrintf.setChecked(False)
        self.ui.chkOption.setChecked(False)
        self.ui.chkEscape.setChecked(False)
        self.ui.chkTab.setChecked(False)
        
        self.ui.chkStWhiteSpc.setChecked(False)
        self.ui.chkEndWhiteSpc.setChecked(False)
        self.ui.chkDoubleSpace.setChecked(False)
        self.ui.chkPuncSpace.setChecked(False)
        
        self.ui.chkGlossary.setChecked(True)
        self.ui.leGeneral.clear()
        self.ui.leNones.clear()
        self.ui.leVerbs.clear()
        self.ui.leAdjectives.clear()
        
        self.ui.chkSingleQuot.setChecked(False)
        self.ui.chkDoubleQuot.setChecked(False)
        self.ui.chkBracket.setChecked(False)
        self.ui.chkDoubleWord.setChecked(False)
        self.ui.chkSentenceCount.setChecked(False)
        self.ui.chkXmlTagAtt.setChecked(False)
        self.ui.chkXmlTag.setChecked(False)
        
        self.ui.chkVariable.setChecked(True)
        self.ui.chkVariable.setEnabled(True)
        self.ui.cbxVariable.setEnabled(True)
        self.ui.chkAccelerator.setChecked(True)
        self.ui.cbxAccelerator.setEnabled(True)
        self.ui.cbxAccelerator.setCurrentIndex(0)
        self.ui.leAccelerator.setEnabled(True)
        self.ui.leAccelerator.setText("~")
        
        self.ui.chkEnable.setChecked(True)
        self.ui.leFullStop.clear()
        self.ui.leQuestionMark.clear()
        self.ui.leExcla.clear()
        self.ui.leSemiColon.clear()
        self.ui.leColon.clear()
        self.ui.leElipsis.clear()
        self.ui.leComma.clear()
        
        self.ui.chkStore.setChecked(True)
        self.ui.chkErrorShow.setChecked(True)
        
        
    def set_error_options_list(self):
        #list of all checkbox and line edit in the error checking page of preference
        self.errorOptionList=[]        
        self.errorOptionList.append(self.ui.chkEmail)
        self.errorOptionList.append(self.ui.chkUrl)
        self.errorOptionList.append(self.ui.chkFunction)
        self.errorOptionList.append(self.ui.chkFilePath)
        self.errorOptionList.append(self.ui.chkNewLine)
        self.errorOptionList.append(self.ui.chkPrintf)
        self.errorOptionList.append(self.ui.chkOption)
        self.errorOptionList.append(self.ui.chkEscape)
        self.errorOptionList.append(self.ui.chkTab)
        
        self.errorOptionList.append(self.ui.chkStWhiteSpc)
        self.errorOptionList.append(self.ui.chkEndWhiteSpc)
        self.errorOptionList.append(self.ui.chkDoubleSpace)
        self.errorOptionList.append(self.ui.chkPuncSpace)
        
        self.errorOptionList.append(self.ui.chkGlossary)
        self.errorOptionList.append(self.ui.leGeneral)
        self.errorOptionList.append(self.ui.leNones)
        self.errorOptionList.append(self.ui.leVerbs)
        self.errorOptionList.append(self.ui.leAdjectives)
        
        self.errorOptionList.append(self.ui.chkSingleQuot)
        self.errorOptionList.append(self.ui.chkDoubleQuot)
        self.errorOptionList.append(self.ui.chkBracket)
        self.errorOptionList.append(self.ui.chkDoubleWord)
        self.errorOptionList.append(self.ui.chkSentenceCount)  
        self.errorOptionList.append(self.ui.chkXmlTagAtt)
        self.errorOptionList.append(self.ui.chkXmlTag) 
        
        self.errorOptionList.append(self.ui.chkVariable)
        
        self.errorOptionList.append(self.ui.chkAccelerator)
        self.errorOptionList.append(self.ui.cbxAccelerator)
        self.errorOptionList.append(self.ui.leAccelerator)
        
        self.errorOptionList.append(self.ui.chkEnable)
        self.errorOptionList.append(self.ui.leFullStop)
        self.errorOptionList.append(self.ui.leQuestionMark)
        self.errorOptionList.append(self.ui.leExcla)
        self.errorOptionList.append(self.ui.leSemiColon)
        self.errorOptionList.append(self.ui.leColon)
        self.errorOptionList.append(self.ui.leElipsis)
        self.errorOptionList.append(self.ui.leComma)
        
        self.errorOptionList.append(self.ui.chkStore)
        self.errorOptionList.append(self.ui.chkErrorShow) 
        
        return self.errorOptionList
        
    def set_Accelerator_list(self):
        #Accelerator list
        self.AccList=[]
        self.AccList.append("openoffice")
        self.AccList.append("Mozilla")
        self.AccList.append("KDE")
        self.AccList.append("Gnome")
        self.AccList.append("UserDefine")
        
        return self.AccList
        
    def set_Variable_list(self):
        #Variable list
        self.VariableList=[]
        self.VariableList.append("openoffice")
        self.VariableList.append("Mozilla")
        self.VariableList.append("KDE")
        self.VariableList.append("Drupal")
        self.VariableList.append("None")
        return self.VariableList
    
    def set_acceleratorValue_list(self):
        #list of accelerator value
        self.AccValueList=[]
        self.AccValueList.append("~")
        self.AccValueList.append("&")
        self.AccValueList.append("&")
        self.AccValueList.append("_")
        return self.AccValueList
    
    def set_punctuation_list(self):
        #list of punctuation
        self.punctuationList=[]
        self.punctuationList.append(".")
        self.punctuationList.append("?")
        self.punctuationList.append("!")
        self.punctuationList.append(";")
        self.punctuationList.append(":")
        self.punctuationList.append("...")
        self.punctuationList.append(",")
        return self.punctuationList
    
    def set_error_node_list(self):
        #list of nodes in xml file
        self.errorNodeList=[]
        self.errorNodeList.append("emails")
        self.errorNodeList.append("urls")
        self.errorNodeList.append("functions")
        self.errorNodeList.append("filepaths")
        self.errorNodeList.append("newlines")
        self.errorNodeList.append("printf") 
        self.errorNodeList.append("options")
        self.errorNodeList.append("escapes")
        self.errorNodeList.append("tabs")
        
        self.errorNodeList.append("startwhitespace")
        self.errorNodeList.append("endwhitespace")
        self.errorNodeList.append("doublespacing")
        self.errorNodeList.append("puncspacing")
        
        self.errorNodeList.append("glossarytest")
        self.errorNodeList.append("general")
        self.errorNodeList.append("glossaryNones")
        self.errorNodeList.append("glossaryVerbs")
        self.errorNodeList.append("glossaryAdjectives")
        
        self.errorNodeList.append("singlequoting")
        self.errorNodeList.append("doublequoting")
        self.errorNodeList.append("brackets")
        self.errorNodeList.append("doublewords") 
        self.errorNodeList.append("sentencecount")
        self.errorNodeList.append("xmltagsAtt")
        self.errorNodeList.append("xmltags")
        
        self.errorNodeList.append("variables")
        
        self.errorNodeList.append("accelerators")
        self.errorNodeList.append("AcceleratorProgram")
        self.errorNodeList.append("AcceleratorMark")
        
        self.errorNodeList.append("EndpunctuationEnable")
        self.errorNodeList.append("Fullstop")
        self.errorNodeList.append("QuestionMark")
        self.errorNodeList.append("ExclamatoryMark")
        self.errorNodeList.append("Semicolon")
        self.errorNodeList.append("Colon")
        self.errorNodeList.append("Elipsis")
        self.errorNodeList.append("Comma")
        
        self.errorNodeList.append("StoreEnable")
        self.errorNodeList.append("ShowErrorEnable")
        return self.errorNodeList
        
    def make_File(self, filename=""):
        #code for making xml file
        self.fileName=filename
        self.country=World.settings.value("selfCountry").toString()
        self.language=World.settings.value("selfLanguage").toString()
        self.fileCode= self.language + "_" +self.country
        if not filename:
            self.fileName=self.filename.replace ( '/', 'Or' )
        self.filePath=''
        #        self.filePath = os.path.abspath(localpath + "../test_files/" + self.fileName)
        self.filePath = os.path.abspath(homePath + self.fileName)
        
        self.globalFilePath=self.filePath
        self.filePath=self.filePath.replace("[", "")          
        self.filePath=self.filePath.replace("]", "")                                              
        self.xmlfile=QtCore.QFile(self.filePath)
        self.fp = open(self.filePath,'w')
#      Added file encoding for windows.
        if (platform.system() is "Windows"):
            self.fp.write ("<?xml version=\"1.0\" encoding=\"windows-1252\"?>" )
        self.fp.write ("<!DOCTYPE ErrorOperation>" ) 
        self.fp.write ("<ErrorCheckingOptions>" ) 
        self.fp.write ("</ErrorCheckingOptions>" )
        self.fp.close() 
        
        doc = QtXml.QDomDocument( "ErrorChecking" );
        if self.xmlfile.open(QtCore.QIODevice.ReadWrite | QtCore.QIODevice.Text) == 0:
            print "cannot open file make_file"
        if doc.setContent( self.xmlfile ) == 0:
           self.xmlfile.close()
        self.xmlfile.close()
        return doc
        
    def write_file(self, iso2list):
        #writing the IS3 language into the language file
        #        filepath=  os.path.abspath(localpath + "../test_files/sorted_language_code")
        filepath = os.path.abspath(homePath + "sorted_language_code")
        fp = open(filepath, 'w')
        for i in iso2list:
            fp.write(i)
        fp.close() 
    
    def writeMoreLanguage(self, object): 
        #writes the ISO3 language code that has been previously selected by user in the list of ISO2 language code.
        currentlanguage=str(object.currentText())
        currentlanguage= currentlanguage +"\n"
        iso2list=self.load_language_ISO2(object)
        flagwrite=0   
        for i in iso2list:
            if i!=currentlanguage:
                flagwrite=1
                continue
            else:  
                k=i
                flagwrite=0
                break    
        
        if flagwrite:      
            iso2list.append(currentlanguage)
            self.write_file(iso2list)   
            
    def load_countries(self, object):
        #load country list for country combo box 
        filepath = os.path.abspath(homePath + "sorted_country_code")
#        filepath = os.path.abspath(localpath + "../test_files/sorted_country_code")
#        absPath=os.getcwd()
        self.countryList=[]
        
        fp = open(filepath)
        fileList = fp.readlines()
        for fileLine in fileList:
            fileLine=unicode(fileLine[:-1])
            self.countryList.append(fileLine)
        fp.close()
        object.addItems(self.countryList)
#        object.addItems(self.countryList)
        return self.countryList
        
    def load_language_ISO2(self, object):
        #load ISO2 language list for country combo box 
        filepath = os.path.abspath(homePath + "sorted_language_code")
        iso2list=[]
        self.List=[]
        fp = open(filepath)
        fileList = fp.readlines()
        for fileLine in fileList:
            iso2list.append(fileLine)
            fileLine=fileLine[:-1]
            fileLine=unicode(fileLine)
            self.List.append(fileLine)
        fp.close() 
        currentindex=World.settings.value("ErrorcurrentLanguage").toString()
        for i in self.List:
            if i!=currentindex:
                break
        
        object.clear()
        object.addItems(self.List)
        
        return iso2list
        
    def load_language_ISO3(self, object):
        #load ISO3 language list for country combo box 
        filepath = os.path.abspath(homePath + "sorted_language_code_ISO3")
        self.iso3List=[]
        fp = open(filepath)
        fileList = fp.readlines()
        for fileLine in fileList:
            fileLine=fileLine[:-1]
            fileLine=unicode(fileLine)
            self.iso3List.append(fileLine)
        fp.close() 
        object.addItems(self.iso3List)
        object.addItems(self.iso3List)
#        self.ui.cbxLanguage.addItems(self.iso3List)
#        self.ui.cbxLanguageCode.addItems(self.iso3List)
        
    def add_node(self, r1, doc, nodename, nodevalue):
        #code for adding node in xml file
        SingeQuot = doc.createElement( nodename )
        r1.appendChild( SingeQuot )
        nodevalue = str(nodevalue)
        txt = doc.createTextNode(nodevalue)
        SingeQuot.appendChild( txt )
        
    def addLineEditTest(self,  std, doc,  j):    
        #code for storing data in xml file that is inserted through checkbox widgets
        nodelist=[]
        nodelist=self.set_error_node_list()
        nodename=nodelist[j]
        errorlist=[]
        errorlist=self.set_error_options_list()
        nodevalue1= errorlist[j]
        nodevalue=unicode(nodevalue1.displayText())
#        nodevalue=nodevalue.decode('utf-8')
        nodelist=[]
        nodelist=self.set_error_node_list()
        nodename=nodelist[j]
        if nodevalue==""  or self.punctuationEnableFlag==0:
            if nodename=="Fullstop":
                nodevalue="."
            elif nodename=="QuestionMark":
                nodevalue="?"    
            elif nodename=="ExclamatoryMark":
                nodevalue="!"
            elif nodename=="Semicolon":
                nodevalue=";"
            elif nodename=="Colon":
                nodevalue=":"
            elif nodename=="Elipsis":
                nodevalue="..."
            elif nodename=="Comma":
                nodevalue=","
                
            if nodevalue==""  or self.glossaryEnableFlag==0:    
                if nodename=="general" or nodename=="glossaryNones" or nodename=="glossaryVerbs" or nodename=="glossaryAdjectives" :
                    nodevalue="0"

        doublequot=doc.createElement( nodename )
        txt = doc.createTextNode(nodevalue)
        doublequot.appendChild( txt )
        std.appendChild(doublequot)
        
        
    def addCheckTest(self,  std, doc , j):   
        #code for storing data in xml file that is inserted through checkbox widgets
        self.userLen=''
        nodevalue=''
        nodename=''
        errorlist=[]
        errorlist=self.set_error_options_list()
        nodevalue1= errorlist[j]
        nodelist=[]
        nodelist=self.set_error_node_list()
        nodename=nodelist[j]
        if nodename=="accelerators":
            nodevalue=nodevalue1.isChecked()
            nodevalue=str(nodevalue)
            user=self.ui.leAccelerator.text()
            user=str(user)
            user=user.split()
            self.userLen=len(user)
            if len(user)==0:
                nodevalue="False"
            if nodevalue=="True":
                self.acceleratorFlag= 1
            else:
                self.acceleratorFlag= 0
        if nodename!="AcceleratorProgram" and nodename!="AcceleratorMark" and nodename!="accelerators":
            nodevalue=nodevalue1.isChecked()
            nodevalue=str(nodevalue)
    
        if nodename=="variables":
            if nodevalue=="True":
                nodevalue=self.ui.cbxVariable.currentText()
            else:     
                nodevalue="False"

        if nodename=="AcceleratorProgram":
            if self.acceleratorFlag== 1:
                nodevalue=self.ui.cbxAccelerator.currentText()

            else:
                nodevalue="False"
        
        if nodename== "AcceleratorMark":
            if self.acceleratorFlag==1:
                nodevalue=self.ui.leAccelerator.text()
            else:
                nodevalue="False"  
        
        doublequot=doc.createElement( nodename )
        txt = doc.createTextNode(nodevalue)
        doublequot.appendChild( txt )
        std.appendChild(doublequot)
        
    
    def add_test(self):
        #code for adding value in the xml file
        self.punctuationEnableFlag=0
        self.glossaryEnableFlag=0
        self.acceleratorFlag= 0
        doc=self.doc
        filecode=self.fileCode
        root = doc.documentElement()
        std = doc.createElement( "Language" )
        root.appendChild( std )
        std.setAttribute( "code", filecode )
        addCount=-1
        subnode=13   
        for k in range(subnode):
            addCount=addCount+1
            self.addCheckTest(std, doc, addCount )
        
        addCount=addCount+1
        chkGlossary=self.ui.chkGlossary.isChecked()
        nodename="glossarytest"
        self.add_node(std, doc, nodename, chkGlossary) 
        count=4
        if(chkGlossary):
            for k in range(count):                
                addCount=addCount+1
                self.glossaryEnableFlag=1
                self.addLineEditTest(std, doc,  addCount)
        else:
            for k in range(count):                
                addCount=addCount+1
                self.glossaryEnableFlag=0
                self.addLineEditTest(std, doc,  addCount)

        subnode=11   
        for k in range(subnode):
            addCount=addCount+1
            self.addCheckTest(std, doc, addCount )
        
        addCount=addCount+1
        grbxEndPunc=self.ui.chkEnable.isChecked()
        nodename="punctuationEnable"
        self.add_node(std, doc, nodename, grbxEndPunc) 
        count=7
        if(grbxEndPunc):
            for k in range(count):                
                addCount=addCount+1
                self.punctuationEnableFlag=1
                self.addLineEditTest(std, doc,  addCount)
        else:
            for k in range(count):                
                addCount=addCount+1
                self.punctuationEnableFlag=0
                self.addLineEditTest(std, doc, addCount )
        
        subnode=2
        for k in range(subnode):
            addCount=addCount+1
            self.addCheckTest(std, doc, addCount )
        
        if self.xmlfile.open(QtCore.QIODevice.WriteOnly | QtCore.QIODevice.Text) == 0:
            print "cannot open file add_test"
     
        ts = QtCore.QTextStream(self.xmlfile)
        ts << doc.toString()
        self.xmlfile.close()
        self.pressNewLang=False
        self.close()
        
    def set_error_checking_options(self):    
        #initiated the error checking operations. 
        self.Flag=0

        doc=self.add_test()        
    #start of error checking codes by Aditi    
    def accepted(self):
        """ slot ok pressed """
        globalClass.globalerrorlist=[]
        globalClass.endpunclist = defaultdict(dict)
        globalClass.glossaryOptionslist = defaultdict(dict)
        

        self.rememberFont(self.widget[0], self.__overViewFont__)
        self.rememberFont(self.widget[1], self.__tuSourceFont__)
        self.rememberFont(self.widget[2], self.__tuTargetFont__)
        self.rememberFont(self.widget[3], self.__commentFont__)
        self.rememberFont(self.widget[4], self.overviewHeaderFont)
        self.rememberFont(self.widget[5], self.__TMFont__)
        self.rememberFont(self.widget[6], self.__glossaryFont__)

        self.rememberColor(self.widget[0], self.__overviewColorObj__)
        self.rememberColor(self.widget[1], self.__tuSourceColorObj__)
        self.rememberColor(self.widget[2], self.__tuTargetColorObj__)
        self.rememberColor(self.widget[3], self.__commentColorObj__)
        self.rememberColor(self.widget[5], self.__TMColorObj__)
        self.rememberColor(self.widget[6], self.__glossaryColorObj__)

        World.settings.setValue("UserName", QtCore.QVariant(self.ui.UserName.text()))
        World.settings.setValue("EmailAddress", QtCore.QVariant(self.ui.EmailAddress.text()))
#        World.settings.setValue("FullLanguage", QtCore.QVariant(self.ui.lineFullLang.text()))
        World.settings.setValue("FullLanguage", QtCore.QVariant(self.ui.cbxLanguageCode.currentText()))
        World.settings.setValue("Code", QtCore.QVariant(self.ui.cbxLanguageCode.currentIndex()))
#        World.settings.setValue("Code", QtCore.QVariant(self.ui.cbxLanguageCode.currentText()))
        World.settings.setValue("CountryCode", QtCore.QVariant(self.ui.cbxCountryCode.currentIndex()))
#        World.settings.setValue("CountryCode", QtCore.QVariant(self.ui.cbxCountryCode.currentIndex()))
        World.settings.setValue("perCountryName", QtCore.QVariant(self.ui.cbxCountryCode.currentText()))
        World.settings.setValue("SupportTeam", QtCore.QVariant(self.ui.SupportTeam.text()))
        World.settings.setValue("nPlural", QtCore.QVariant(self.ui.spinBox.value()))
        
        World.settings.setValue("TM_min", QtCore.QVariant(self.ui.spnMin.value()))
#        World.settings.setValue("max", QtCore.QVariant(self.ui.spnMax.value()))
        World.settings.setValue("TM_TargetInclusion", QtCore.QVariant(self.ui.chkTargetInclusion.isChecked()))
        World.settings.setValue("TM_GLb4TM", QtCore.QVariant(self.ui.chkGLb4TM.isChecked()))
        World.settings.setValue("FuzzyGLb4TM", QtCore.QVariant(self.ui.FuzzyGLb4TM.isChecked()))
        World.settings.setValue("TM_max", QtCore.QVariant(self.ui.spnTarget.value()))
        World.settings.setValue("TM_max_candidates", QtCore.QVariant(self.ui.spnMaxSuggestions.value()))

        World.settings.setValue("TM_max_string_len", QtCore.QVariant(self.ui.spnMaxLen.value()))
        World.settings.setValue("TM_MarkStringAsFuzzy", QtCore.QVariant(self.ui.chbMarkStringAsFuzzy.isChecked()))
        World.settings.setValue("TM_AddSuggestions", QtCore.QVariant(self.ui.chkAddSuggestions.isChecked()))
        World.settings.setValue("TM_IncludeFuzzy", QtCore.QVariant(self.ui.chkIncludeFuzzy.isChecked()))
        World.settings.setValue("TM_EliminateIdentical", QtCore.QVariant(self.ui.chkEliminateIdentical.isChecked()))
        World.settings.setValue("TM_Instant", QtCore.QVariant(self.ui.chkInstant.isChecked()))
        
        World.settings.setValue("equation", QtCore.QVariant(self.ui.lineEqaution.text()))
        World.settings.setValue("headerAuto", QtCore.QVariant(self.ui.chkHeaderAuto.checkState() == QtCore.Qt.Checked))
        World.settings.setValue("cursorHome", QtCore.QVariant(self.ui.chkCursorHome.checkState() == QtCore.Qt.Checked))

        World.settings.setValue("GlossaryPreference", QtCore.QVariant(self.setGlossaryOptions())) 
        World.settings.setValue("activeDictionary", QtCore.QVariant(self.__activeDictionary__))
        globalClass.createDictFlag = 1
        self.parent.operator.checkAvailableDict()

        previousNotHighlightInSourceValue = World.settings.value("notHighlightInSource", QtCore.QVariant(True)).toBool()
        currentNotHighlightInSourceValue = self.ui.chkSpellIgnoreSource.isChecked()
        if currentNotHighlightInSourceValue != previousNotHighlightInSourceValue:
            World.settings.setValue("notHighlightInSource", QtCore.QVariant(currentNotHighlightInSourceValue))
            self.parent.operator.spellCheckIgnoreSource = currentNotHighlightInSourceValue
            if self.parent.ui.actionAutoSpellCheck.isChecked():
                globalClass.sourceWordFlag = 1
                self.parent.operator.autoSpellCheck(True)

        World.settings.setValue("autoSaveInterval", QtCore.QVariant(self.ui.QSpinBoxAutoSave.value()))
        World.settings.setValue("EnableAutoSave", QtCore.QVariant(self.ui.checkBox.isChecked()))
        
        self.emit(QtCore.SIGNAL("settingsChanged"))
        
        #invisible characters
        World.settings.setValue("invisiblecharacater", QtCore.QVariant(self.ui.chkwordpros.isChecked()))    
    
        #current language
        World.settings.setValue("warningLangMismatch", QtCore.QVariant(self.ui.chkshowwanring.isChecked()))    
        #plural expression 
        self.check_plural_expression_changes()
        #code  starts for error checking##################################
        World.settings.setValue("currentCountry", QtCore.QVariant(self.ui.cbxCountry.currentIndex()))
        World.settings.setValue("ErrorcurrentLanguage", QtCore.QVariant(self.ui.cbxLanguage.currentText()))
        self.doc=self.make_File()
        self. set_error_checking_options()
        languagecode=self.striplangcontryname(self.ui.cbxLanguageCode.currentText(), self.ui.cbxCountryCode.currentText())
        World.settings.setValue("enableGlossary", QtCore.QVariant(self.ui.chkGlossary.isChecked()))
        World.settings.setValue("enableStore", QtCore.QVariant(self.ui.chkStore.isChecked()))
        World.settings.setValue("enableErrorShow", QtCore.QVariant(self.ui.chkErrorShow.isChecked()))
        
        World.settings.setValue("CurrentUserDefineAccelerator", QtCore.QVariant(self.ui.leAccelerator.text()))
        World.settings.setValue("enableVariable", QtCore.QVariant(self.ui.chkVariable.isChecked()))
        World.settings.setValue("enableAccelerator", QtCore.QVariant(self.ui.chkAccelerator.isChecked())) 
        World.settings.setValue("enablePunctuation", QtCore.QVariant(self.ui.chkEnable.isChecked())) 
        
        World.settings.setValue("variableList", QtCore.QVariant(self.ui.chkVariable.checkState() == QtCore.Qt.Checked))
        World.settings.setValue("AcceleratorList", QtCore.QVariant(self.ui.chkAccelerator.checkState() == QtCore.Qt.Checked))
        
        
        self.writeMoreLanguage(self.ui.cbxLanguage)    
        self.writeMoreLanguage(self.ui.cbxLanguageCode)
        if self.ui.cbxAccelerator.currentText()=="UserDefine":
            userhere=self.ui.leAccelerator.text()
            World.settings.setValue("UserDefineAccelerator", QtCore.QVariant(self.ui.leAccelerator.text()))  
        if self.parent.operator.filepath4error:            
            abs=self.parent.operator.filepath4error        
    #        abs=os.path.abspath(self.globalFilePath)
            World.settings.setValue("activeErrorCheckingFilePath", QtCore.QVariant(abs))
            tagValueList=[]
            try:
                tagValueList=self.load_file(abs)
                self.loadGlobalPreferenceValue(tagValueList)
            except:    
                pass
  
        chkStore=self.ui.chkStore.isChecked()
        self.parent.dockTUview.setHighlightGlossary(True)
        self.parent.dockTUview.sourceHighlighter.chckaccelerator(globalClass.endPuncDict)
        self.parent.dockTUview.targetHighlighter.chckaccelerator(globalClass.endPuncDict)        
          
#code  ends for error checking##################################
    #thesaurus settings:
        World.settings.setValue("sourcelanguage", QtCore.QVariant(self.ui.thessourcelang.currentIndex()))
        World.settings.setValue("sourcecountry", QtCore.QVariant(self.ui.thessourceCoun.currentIndex()))

    def rememberFont(self, obj, fontObj):
        """ remember Font in Qsettings
        @param obj: input as string
        @param fontObj: stored font"""
        World.settings.setValue(str(obj + "Font"), QtCore.QVariant(fontObj.toString()))

    def rememberColor(self, obj, colorObj):
        """ remember Color in Qsettings
        @param obj: input as string
        @param colorObj: stored color"""
        World.settings.setValue(str(obj + "Color"), QtCore.QVariant(colorObj.name()))

    def fontOverview(self):
        """ slot to open font selection dialog """
        self.__overViewFont__ = self.setFont(self.widget[0])
        self.setCaption(self.ui.lblOverView, self.__overViewFont__)
        
    def fontSource(self):
        """ slot to open font selection dialog """
        self.__tuSourceFont__ = self.setFont(self.widget[1])
        self.setCaption(self.ui.lblSource, self.__tuSourceFont__)
        
    def fontTarget(self):
        """ slot to open font selection dialog """
        self.__tuTargetFont__ = self.setFont(self.widget[2])
        self.setCaption(self.ui.lblTarget, self.__tuTargetFont__)

    def fontComment(self):
        """ slot to open font selection dialog """
        self.__commentFont__ = self.setFont(self.widget[3])
        self.setCaption(self.ui.lblComment, self.__commentFont__)
        
    def fontOverviewHeader(self):
        """ slot to open font selection dialog """
        self.overviewHeaderFont = self.setFont(self.widget[4])
        self.setCaption(self.ui.lblOverViewHeader, self.overviewHeaderFont)
        
    def fontTM(self):
        """ slot to open font selection dialog """
        self.__TMFont__ = self.setFont(self.widget[5])
        self.setCaption(self.ui.lblTM, self.__TMFont__)
    
    def fontGlossary(self):
        """ slot to open font selection dialog """
        self.__glossaryFont__ = self.setFont(self.widget[6])
        self.setCaption(self.ui.lblGlossary, self.__glossaryFont__)

    def colorOverview(self):
        """ slot to open color selection dialog """
        self.__overviewColorObj__ = self.setColor(self.widget[0])
        self.setTextColor(self.ui.lblOverView, self.__overviewColorObj__)

    def colorSource(self):
        """ slot to open color selection dialog """
        self.__tuSourceColorObj__ = self.setColor(self.widget[1])
        self.setTextColor(self.ui.lblSource, self.__tuSourceColorObj__)

    def colorTarget(self):
        """ slot to open color selection dialog """
        self.__tuTargetColorObj__ = self.setColor(self.widget[2])
        self.setTextColor(self.ui.lblTarget, self.__tuTargetColorObj__)

    def colorComment(self):
        """ slot to open font selection dialog """
        self.__commentColorObj__ = self.setColor(self.widget[3])
        self.setTextColor(self.ui.lblComment, self.__commentColorObj__)
        
    def colorTM(self):
        """ slot to open font selection dialog """
        self.__TMColorObj__ = self.setColor(self.widget[5])
        self.setTextColor(self.ui.lblTM, self.__TMColorObj__)
    
    def colorGlossary(self):
        """ slot to open font selection dialog """
        self.__glossaryColorObj__ = self.setColor(self.widget[6])
        self.setTextColor(self.ui.lblGlossary, self.__glossaryColorObj__)

    def getFont(self, obj):
        """@return obj: font object created from settings
        @param obj: widget whose font is gotten from"""
        font = World.settings.value(str(obj + "Font"), QtCore.QVariant(self.defaultFont.toString()))
        if (font.isValid()):
            fontObj = QtGui.QFont()
            if (fontObj.fromString(font.toString())):
                return fontObj
        return self.defaultFont

    def getColor(self, obj):
        """@return obj: color object created from settings
        @param obj: widget whose color is gotten from"""
        color = World.settings.value(str(obj + "Color"), QtCore.QVariant(self.defaultColor.name()))
        colorObj = QtGui.QColor(color.toString())
        return colorObj

    def defaultFonts(self):
        """slot Set default fonts"""
        self.setCaption(self.ui.lblOverView, self.defaultFont)
        self.__overViewFont__ = self.defaultFont
        self.setCaption(self.ui.lblOverViewHeader, self.defaultFont)
        self.overviewHeaderFont = self.defaultFont
        self.setCaption(self.ui.lblSource, self.defaultFont)
        self.__tuSourceFont__ = self.defaultFont
        self.setCaption(self.ui.lblTarget, self.defaultFont)
        self.__tuTargetFont__ = self.defaultFont
        self.setCaption(self.ui.lblComment, self.defaultFont)
        self.__commentFont__ = self.defaultFont
        self.setCaption(self.ui.lblTM, self.defaultFont)
        self.__TMFont__ = self.defaultFont
        self.setCaption(self.ui.lblGlossary, self.defaultFont)
        self.__glossaryFont__ = self.defaultFont

    def AdjustAllFonts(self):
        """ slot to open font selection dialog """
        self.adjustAllFonts = self.setFont(self.widget[1])
        self.overviewHeaderFont = self.adjustAllFonts
        self.setCaption(self.ui.lblOverViewHeader, self.overviewHeaderFont)
        self.__overViewFont__ = self.adjustAllFonts
        self.setCaption(self.ui.lblOverView, self.__overViewFont__)
        self.__tuSourceFont__ = self.adjustAllFonts
        self.setCaption(self.ui.lblSource, self.__tuSourceFont__)
        self.__tuTargetFont__ = self.adjustAllFonts
        self.setCaption(self.ui.lblTarget, self.__tuTargetFont__)
        self.__commentFont__ = self.adjustAllFonts
        self.setCaption(self.ui.lblComment, self.__commentFont__)
        self.__TMFont__ = self.adjustAllFonts
        self.setCaption(self.ui.lblTM, self.__TMFont__)
        self.__glossaryFont__ = self.adjustAllFonts
        self.setCaption(self.ui.lblGlossary, self.__glossaryFont__)

    def defaultColors(self):
        """slot Set default colors"""
        self.setTextColor(self.ui.lblOverView, self.defaultColor)
        self.__overviewColorObj__ = self.defaultColor
        self.setTextColor(self.ui.lblSource, self.defaultColor)
        self.__tuSourceColorObj__ = self.defaultColor
        self.setTextColor(self.ui.lblTarget, self.defaultColor)
        self.__tuTargetColorObj__ = self.defaultColor
        self.setTextColor(self.ui.lblComment, self.defaultColor)
        self.__commentColorObj__ = self.defaultColor
        self.setTextColor(self.ui.lblTM, self.defaultColor)
        self.__TMColorObj__ = self.defaultColor
        self.setTextColor(self.ui.lblGlossary, self.defaultColor)
        self.__glossaryColorObj__ = self.defaultColor

    def setCaption(self, lbl, fontObj):
        """ create the text from the font object and set the widget lable
        @param lbl: label widget for setting Font information to
        @param fontObj:  font whose information is set to label widget"""
        newText = fontObj.family() +",  "+ str(fontObj.pointSize())
        if (fontObj.bold()):
            newText.append(", " + self.tr("bold"))
        if (fontObj.italic()):
            newText.append(", " + self.tr("italic"))
        if (fontObj.underline()):
            newText.append(", " + self.tr("underline"))
        lbl.setText(newText)
        
    def setTextColor(self, lbl, colorObj):
        """ set color to the text of lable widget
        @param lbl: label widget for setting color to
        @param colorObj: Color to set to label widget"""
        palette = QtGui.QPalette(lbl.palette())
        palette.setColor(QtGui.QPalette.Active,QtGui.QPalette.ColorRole(QtGui.QPalette.WindowText), colorObj)
        palette.setColor(QtGui.QPalette.Inactive,QtGui.QPalette.ColorRole(QtGui.QPalette.WindowText), colorObj)
        lbl.setPalette(palette)

    def setFont(self, obj):
        """ open font dialog 
        @return selected new font object or the old one if cancel was pressed 
        @param obj: widget whose font is gotten from"""
        oldFont = self.getFont(obj)
        newFont, okPressed = QtGui.QFontDialog.getFont(oldFont)
        if (okPressed):
            return newFont
        return oldFont

    def setColor(self, obj):
        """ open color dialog 
        @return selected new color object or the old one if cancel was pressed
        @param obj: widget whose color is gotten from"""
        oldColor = self.getColor(obj)
        newColor = QtGui.QColorDialog.getColor(QtCore.Qt.white)
        if (newColor.isValid()):
            return newColor
        return oldColor
    
    
    #start of error checking codes by Aditi
    
    def make_level(self, option):
        #code for bulding up level for currentlt selected langugae and country in the preference errorchecking page
        if option=="errorChecking":
            currentList=[]
            currentindex=World.settings.value("currentCountry",  QtCore.QVariant("0")).toInt()[0]

            self.ui.cbxCountry.setCurrentIndex(currentindex)
            currentcountry= str(self.ui.cbxCountry.currentText())

            currentList=self.setCountryLanguage(currentcountry)
            countrycode=currentList[0].replace("[", "")          
            countryname= currentList[1]
            
            currentindex=World.settings.value("ErrorcurrentLanguage",  QtCore.QVariant("Afar [aa]")).toString()

            currentList=[]
            currentList=self.setCountryLanguage(currentindex)
            languagecode=currentList[0].replace("]", "")          
            languagename= currentList[1]
            
            if currentcountry =="No country specified":
                self.levelString=languagename + " " + "[" + languagecode + "]" 
            else:                
                self.levelString=languagename +  " "  + "(" + countryname + ")" + " " + languagecode + "_" + countrycode

            makefilename=languagecode + "_" + countrycode + "_tests.xml"
            self.filename=makefilename.replace("[", "")
            self.filename=self.filename.replace("]", "")
            levelString=unicode(self.levelString)
            self.ui.lbcode.setText(levelString)
            return self.levelString
            
        elif option=="personalization":
            currentList=[]
            currentLanguage=World.settings.value("FullLanguage",  QtCore.QVariant("Afar [aa]")).toString()
            currentList=self.setCountryLanguage(currentLanguage)
            languagecode=currentList[0].replace("]", "")
            languagename= currentList[1]
            currentcountry=World.settings.value("perCountryName",  QtCore.QVariant("AFGHANISTAN [AF]")).toString()
            currentList=self.setCountryLanguage(currentcountry)
            countrycode=currentList[0].replace("[", "")       
            countryname= currentList[1]

            if currentcountry =="No country specified":
                levelString=languagename + " " + "[" + languagecode + "]"
            else:                
                levelString=languagename + " " + "(" + countryname + ")" + " " + languagecode + "_" + countrycode  
            levelString=unicode(levelString)
            self.ui.lbLangCntry.setText(levelString)
            
        elif option=="currentLang":
            currentList=[]
            currentLanguage=self.parent.operator.curlang
            curlangindex=self.parent.operator.curlangindex
            World.settings.setValue("Code", QtCore.QVariant(curlangindex))
            currentList=self.setCountryLanguage(currentLanguage)
            languagecode=currentList[0].replace("]", "")
            clanguagecode=currentList[0].replace("[", "")          
            languagename= currentList[1]

            currentcountry=self.parent.operator.curcontry
            curcontryindex=self.parent.operator.curcontryindex
            World.settings.setValue("CountryCode", QtCore.QVariant(curcontryindex))
            currentList=self.setCountryLanguage(currentcountry)
            countrycode=currentList[0].replace("[", "")          
            ccountrycode=currentList[0].replace("]", "")          
            countryname= currentList[1]

            if currentcountry =="No country specified":
                currenlevelString=languagename + " " + "[" + languagecode + "]" 
            else:                
                currenlevelString=languagename + " " + "(" + countryname + ")" + " " + languagecode + "_" + countrycode
                
            if currentcountry =="No country specified":
                levelString= clanguagecode  
            else:                
                levelString=clanguagecode + "_" + ccountrycode    
            levelString=unicode(levelString)
            return levelString

    #start of error checking codes by Aditi    
    def showDialog(self, tabNumber = 0):
        """ make the dialog visible """
            # lazy init 
        if (not self.ui):
            self.setWindowTitle(self.tr("Preferences"))
            self.setModal(True)
            self.defaultFont = QtGui.QFont("Serif", 10)
            self.defaultColor = QtGui.QColor(QtCore.Qt.black)
            
            from WordForge.Editor.ui.Ui_Preference import Ui_frmPreference
            self.ui = Ui_frmPreference()
            self.ui.setupUi(self)
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/identity.png"), self.tr("Personalize")))
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/colorize.png"), self.tr("Font & Color")))
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/memory.png"), self.tr("TM")))
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/glossary.png"), self.tr("Glossary")))
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/save.png"), self.tr("Save")))
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/editor.png"), self.tr("Editor")))
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/spellcheck.png"), self.tr("Spellcheck")))
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/thesaurus.png"), self.tr("Thesaurus")))
            self.ui.listWidget.addItem(QtGui.QListWidgetItem(QtGui.QIcon(":/Error_checking.png"), self.tr("Error Checking")))
            
            self.ui.listWidget.setGridSize(QtCore.QSize(120, 60))
            self.ui.listWidget.setViewMode(QtGui.QListView.IconMode)
            self.ui.listWidget.setMovement(QtGui.QListView.Static)          # users shall not move the items
            self.ui.listWidget.setCurrentRow(1)
            self.ui.listWidget.setResizeMode(QtGui.QListView.Fixed)
            #This setDragDropMode is mentioned in Qt4.2 only
            self.connect(self.ui.listWidget, QtCore.SIGNAL("currentRowChanged(int)"), self.changedPaged)
            
            # TM page signals
            self.connect(self.ui.chkTargetInclusion, QtCore.SIGNAL("stateChanged(int)"), self.changeFuzzyCheckbox)
            self.connect(self.ui.spnTarget, QtCore.SIGNAL("valueChanged(int)"), self.copyTarget)
            self.connect(self.ui.spnMin, QtCore.SIGNAL("valueChanged(int)"), self.detectMin) 
            self.connect(self.ui.spnTarget, QtCore.SIGNAL("valueChanged(int)"), self.detectMax) 
            self.connect(self.ui.spnMaxLen, QtCore.SIGNAL("valueChanged(int)"), self.detectMax)
            
            # Set time to auto save of maineditor 
            self.connect(self.ui.checkBox, QtCore.SIGNAL("clicked()"), self.setIntervalTimer)
            
            # connect signals
            self.connect(self.ui.chkHeaderAuto, QtCore.SIGNAL("stateChanged(int)"), self.ui.chkHeaderAuto.checkState) 
            self.connect(self.ui.chkCursorHome, QtCore.SIGNAL("stateChanged(int)"), self.ui.chkCursorHome.checkState) 
            self.connect(self.ui.bntFontOverview, QtCore.SIGNAL("clicked()"), self.fontOverview) 
            self.connect(self.ui.bntFontOverviewHeader, QtCore.SIGNAL("clicked()"), self.fontOverviewHeader)
            self.connect(self.ui.bntFontSource, QtCore.SIGNAL("clicked()"), self.fontSource) 
            self.connect(self.ui.bntFontTarget, QtCore.SIGNAL("clicked()"), self.fontTarget)
            self.connect(self.ui.bntFontComment, QtCore.SIGNAL("clicked()"), self.fontComment) 
            self.connect(self.ui.bntFontTM, QtCore.SIGNAL("clicked()"), self.fontTM) 
            self.connect(self.ui.bntFontGlossary, QtCore.SIGNAL("clicked()"), self.fontGlossary) 
            self.connect(self.ui.bntDefaultsFont, QtCore.SIGNAL("clicked()"), self.defaultFonts)
            # set adjust all fonts for all widget
            self.connect(self.ui.bntAdjustAllFont, QtCore.SIGNAL("clicked()"), self.AdjustAllFonts)
            
            # for color
            self.connect(self.ui.btnColorComment, QtCore.SIGNAL("clicked()"), self.colorComment) 
            self.connect(self.ui.btnColorSource, QtCore.SIGNAL("clicked()"), self.colorSource) 
            self.connect(self.ui.btnColorTarget, QtCore.SIGNAL("clicked()"), self.colorTarget) 
            self.connect(self.ui.btnColorOverview, QtCore.SIGNAL("clicked()"), self.colorOverview) 
            self.connect(self.ui.btnColorTM, QtCore.SIGNAL("clicked()"), self.colorTM) 
            self.connect(self.ui.btnColorGlossary, QtCore.SIGNAL("clicked()"), self.colorGlossary) 
            self.connect(self.ui.bntDefaultsColor, QtCore.SIGNAL("clicked()"), self.defaultColors)

#            #for language
#            self.connect(self.ui.cbxLanguageCode, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.setLanguageIndex)
#            self.connect(self.ui.cbxLanguageCode, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.setNPlural)
#
#            self.connect(self.ui.okButton, QtCore.SIGNAL("clicked()"), self.accepted)

            #spellcheck preference
            self.widget = ["overview","tuSource","tuTarget","comment", "overviewHeader", "TM", "Glossary"]
            self.changedSignal = QtCore.SIGNAL("currentCellChanged(int, int, int, int)")
            self.connect(self.ui.download, QtCore.SIGNAL("clicked()"), self.goDownload)
            self.connect(self.ui.btnAdd, QtCore.SIGNAL("clicked()"), self.addDictionary)
            self.connect(self.ui.btnDelete, QtCore.SIGNAL("clicked()"), self.deleteDictionary)
            self.connect(self.ui.DeleteThes, QtCore.SIGNAL("clicked()"), self.deleteThesaurus)
            
            
#            self.connect(self.ui.btnSetActive, QtCore.SIGNAL("clicked()"), self.setActiveDictionary)
#            code =[]
#            language = []
#            import WordForge.translate.lang.data as data
#            for langCode, langInfo in data.languages.iteritems():
#                code.append(langCode)
#                language.append(langInfo[0])
#            code.sort()
#            self.ui.cbxLanguageCode.addItems(code)
        
            #code for showing error checking options in the language code combobox
            currentIndex=0
            country=[]
            language=[]
            iso2list=[]
            self.load_countries(self.ui.cbxCountry)
            self.load_countries(self.ui.cbxCountryCode)
            iso2list=self.load_language_ISO2(self.ui.cbxLanguage)
            iso2list=self.load_language_ISO2(self.ui.cbxLanguageCode)
            variablelist=[]
            variablelist=self.set_Variable_list()
            self.ui.cbxVariable.addItems(variablelist)
            acceleratorlist=[]
            acceleratorlist=self.set_Accelerator_list()
            self.ui.cbxAccelerator.addItems(acceleratorlist)
            acceleratorValuelist=self.set_acceleratorValue_list()
            self.levelString=''
            self.perlevelString=''
            self.levelString=self.make_level("errorChecking")
            self.perlevelString=self.make_level("personalization")
#            if self.ui.cbxAccelerator.currentIndex=="openoffice":
#                self.ui.leAccelerator.setText("~")             
#            World.settings.setValue("CountryLanguageLevel", QtCore.QVariant(self.levelString))

            self.connect(self.ui.cbxLanguage, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.loadLanguageForError)
            self.connect(self.ui.cbxCountry, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.loadCountryForError)
            self.connect(self.ui.chkVariable, QtCore.SIGNAL("clicked()"), self.setVariable)
            self.connect(self.ui.chkAccelerator, QtCore.SIGNAL("clicked()"), self.setAccelerator)
            self.connect(self.ui.chkEnable, QtCore.SIGNAL("clicked()"), self.setPunctuationEnable)
            self.connect(self.ui.chkGlossary, QtCore.SIGNAL("clicked()"), self.setGlossaryEnable)
            self.connect(self.ui.leAccelerator, QtCore.SIGNAL("textEdited(const QString &)"), self.selectUserDefined)
            self.connect(self.ui.chkXmlTagAtt, QtCore.SIGNAL("stateChanged(int)"), self.xmlAttCheckChanged)
            self.connect(self.ui.chkXmlTag, QtCore.SIGNAL("stateChanged(int)"), self.xmlTagCheckChanged)
            self.connect(self.ui.helpButton, QtCore.SIGNAL("clicked()"), self.showHelpDialog)
            
            #for language
            self.connect(self.ui.cbxLanguageCode, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.setLanguageIndex)
            self.connect(self.ui.cbxLanguageCode, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.setNPlural)
            self.connect(self.ui.cbxCountryCode, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.setCountryIndex)
            self.connect(self.ui.cbxAccelerator, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.LoadAcceleratorSymbol)
            self.connect(self.ui.okButton, QtCore.SIGNAL("clicked()"), self.accepted)
            
            #for invisible character
            self.connect(self.ui.chkwordpros, QtCore.SIGNAL("stateChanged(int)"), self.wordprosCheckChanged)
            self.connect(self.ui.chkscaping, QtCore.SIGNAL("stateChanged(int)"), self.scapingCheckChanged)
            
            #for Thesaurus 
            self.connect(self.ui.ChooseThesSource, QtCore.SIGNAL("clicked()"), self.addThesaurus)
            self.connect(self.ui.ChooseThesTarget, QtCore.SIGNAL("clicked()"), self.addThesaurus)
            Thesiso2list=[]
            Thesiso2list=self.load_language_ISO2(self.ui.thessourcelang)
            
            self.load_plural_expression()
            self.load_countries(self.ui.thessourceCoun)
            if self.parent.operator.langcur:
                languageName, countryName=self.find_language_Name(self.parent.operator.langcur)
                self.ui.thestargetlang.setText(languageName)
                self.ui.thestargetcoun.setText(countryName)
            
        else:
#            self.disconnect(self.ui.cbxLanguage, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.setLanguageForError)
            self.load_plural_expression()
            iso2list=[]
            iso2list=self.load_language_ISO2(self.ui.cbxLanguage)
            iso2list=self.load_language_ISO2(self.ui.cbxLanguageCode)
            self.levelString=self.make_level("errorChecking")
            self.perlevelString=self.make_level("personalization")
            if self.parent.operator.langcur:
                languageName, countryName=self.find_language_Name(self.parent.operator.langcur)
                self.ui.thestargetlang.setText(languageName)
                self.ui.thestargetcoun.setText(countryName)
            
#            self.connect(self.ui.cbxLanguage, QtCore.SIGNAL("currentIndexChanged(const QString &)"), self.setLanguageForError)
        self.initUI()
        self.loadDictionaries()
        self.loadThesaurus()
        
        self.show()
        self.ui.listWidget.setFocus()
        self.ui.listWidget.setCurrentRow(tabNumber)
        
    def add_Thesaurus_in_table(self, purpose=""):
        #in the thesaurus table in preferences, adds all the thesaurus files that has been added by users
        u = []
        u = []
        if platform.system() == "Linux":
            dictDirPath = os.path.expanduser('~') + '/.config/WordForge/myThesaurus'
            if not os.path.exists(dictDirPath):
                return
        elif platform.system() == "Windows":
            dictDirPath = os.path.expanduser('~') + '\Application Data\WordForge/myThesaurus'
            if not os.path.exists(dictDirPath):
                return
        listfilewithoutctension=[]
        if purpose=="searchThesFile":
            ThesfileList=os.listdir(dictDirPath)
            return ThesfileList
        for files in os.listdir(dictDirPath):
            filewithourextnsion=files.replace(".dat", "")
            filewithourextnsion=filewithourextnsion.replace(".idx", "")
            listfilewithoutctension.append(filewithourextnsion)            
            for x in listfilewithoutctension:
                if x not in u: u.append(x)   
        return u 
        
    def wordprosCheckChanged(self):
        # ensures that non-prinitng characters will be shown in only one form, either in wordprocessing or in scaping
        if self.ui.chkwordpros.isChecked():
            if self.ui.chkscaping.isChecked():
                self.ui.chkscaping.setChecked(False)
            self.chkwordpros =True   
        else: 
            self.ui.chkscaping.setChecked(True)    
            self.chkwordpros =False  
            
    def scapingCheckChanged(self):
        # ensures that non-prinitng characters will be shown in only one form, either in wordprocessing or in scaping
        if self.ui.chkscaping.isChecked():
            if self.ui.chkwordpros.isChecked():
                self.ui.chkwordpros.setChecked(False) 
            self.chkwordpros =False    
        else:      
            self.ui.chkwordpros.setChecked(True)     
            self.chkwordpros =True
        
        
    def xmlAttCheckChanged(self):
        # ensures that only one of the two checkboxes - showing tag and attribute and showing tags can be checked at a time
        if self.ui.chkXmlTagAtt.isChecked():
            if self.ui.chkXmlTag.isChecked():
                self.ui.chkXmlTag.setChecked(False)
                
                
    def xmlTagCheckChanged(self, state):
        # ensures that only one of the two checkboxes - showing tag and attribute and showing tags can be checked at a time
        if self.ui.chkXmlTag.isChecked():
            if self.ui.chkXmlTagAtt.isChecked():
                self.ui.chkXmlTagAtt.setChecked(False)            

    def showHelpDialog(self):
        # showing the help window in the error checking page 
        from WordForge.Editor.modules.ErrorCheckingHelp import ErrorCheckingHelp
        if (not hasattr(self, "errorOptionsHelp") ):
            self.errorOptionsHelp = ErrorCheckingHelp(self)
        self.errorOptionsHelp.showDialog()

    def selectUserDefined(self, changeText):
        # code for manipulation of user define accelerator
        self.ui.cbxAccelerator.setCurrentIndex(4)
        
    def loadGlobalPreferenceValue(self, lst5):
        #store the value of active xml file in the global lists and dictionary
        nodeList=[]
        localErrorList=[]
        nodeList=self.set_error_node_list()
        localCheckingDict = {}
        j=-1
        subnode=30
        for k in range(subnode):
            j=j+1
            nodeName= nodeList[j]
            nodeValue=lst5[j]
            nodeValue=str(nodeValue)
            if nodeValue=="True" :
                localErrorList.append(nodeName)
                
            if nodeValue!="False" and nodeName=="variables":
                localErrorList.append(nodeName)
                localCheckingDict[nodeName]=nodeValue
                
            if nodeName=="AcceleratorProgram":
                accProgram=nodeValue
                
            if nodeName=="AcceleratorMark":
                accMarks=unicode(nodeValue)
                localCheckingDict[accProgram]=accMarks 
                
        localCheckingDict["accelerators"]=accProgram
        localCheckingDict[accProgram]=accMarks       
            
        j=13  
        nodeValue=lst5[j]
        glossaryEnabledValue=str(nodeValue)
        subnode=4
        for k in range(subnode):
            j=j+1
            nodeName= nodeList[j]

            nodeValue=lst5[j]
            nodeValue=str(nodeValue)
            if glossaryEnabledValue=="True":
                localCheckingDict[nodeName]=nodeValue
            else:
                nodeValue='0'
                localCheckingDict[nodeName]=nodeValue
        
        punctuationList=[]
        punctuaionList=self.set_punctuation_list()
        punctuationCount=-1
        j=29
        nodeValue=lst5[j]
        punctuationEnabledValue=str(nodeValue)
        subnode=7
        for k in range(subnode):
            j=j+1
            nodeName= nodeList[j]
            nodeName=unicode(nodeName)
            nodeValue=lst5[j]
            nodeValue=str(nodeValue)
            nodeValue=unicode(nodeValue)
            if punctuationEnabledValue=="True":
                punctuationCount=punctuationCount+1    
                nodeName=punctuaionList[punctuationCount]
                localCheckingDict[nodeName]=nodeValue
            else:
                punctuationCount=punctuationCount+1    
                nodeValue=punctuaionList[punctuationCount]
                nodeValue=unicode(nodeValue)
                localCheckingDict[nodeValue]=nodeValue
                
        globalClass.globalerrorlist=localErrorList 
        globalClass.endPuncDict=localCheckingDict
        
        puncList=[]
        
        for i in globalClass.preferencePuncList:
            puncList.append(globalClass.endPuncDict[i])  
        for each in puncList:
            if each not in globalClass.targetReplaceChars:
                globalClass.targetReplaceChars = globalClass.targetReplaceChars +each
#        print "glolist", globalClass.globalerrorlist
#        print "glodict", globalClass.endPuncDict
                
                
    def set_flag(self, nodeValue):
        boolValue = bool('true')
        if nodeValue == "False":
                    boolValue=bool('')
        return boolValue
        
    def enablePunctionGlossary(self, test,  isenable):
        # enables punctuations and glossary error checking 
        if test=="punctuation":
            self.ui.leFullStop.setEnabled(isenable)
            self.ui.leQuestionMark.setEnabled(isenable)
            self.ui.leExcla.setEnabled(isenable)
            self.ui.leSemiColon.setEnabled(isenable)
            self.ui.leColon.setEnabled(isenable)
            self.ui.leElipsis.setEnabled(isenable)
            self.ui.leComma.setEnabled(isenable)
        if test=="glossary":
            self.ui.leGeneral.setEnabled(isenable)
            self.ui.leNones.setEnabled(isenable)
            self.ui.leVerbs.setEnabled(isenable)
            self.ui.leAdjectives.setEnabled(isenable)

    def set_checked_value(self, showCount, errorlist, lst5):   
        # sets the values of the errorchecking options from xml file into the fields at Preferences-> Errorchecking.
        errorObject= errorlist[showCount]
        nodeValue=lst5[showCount]
        boolValue=self.set_flag(nodeValue)
        errorObject.setChecked(boolValue)
        return nodeValue

    def set_value(self, lst5):
        #code for reading value from the xml file
        self.accValue=[]
        self.accValue=self.set_acceleratorValue_list()
        showCount=-1
        subnode=13  
        errorlist=[]
        errorlist=self.set_error_options_list()
        for k in range(subnode):
            
            showCount=showCount+1
            checkedValue=self.set_checked_value(showCount, errorlist, lst5)
                
        showCount=showCount+1
        glossaryEnableValue=self.set_checked_value(showCount, errorlist, lst5)

        if glossaryEnableValue!='False':
            self.enablePunctionGlossary("glossary", True )

            count=4
            for i in range(count):
                showCount=showCount+1
                checkvalue=lst5[showCount]
                errorObject= errorlist[showCount]
                errorObject.setText(checkvalue)
        else:  
            showCount=showCount+4
            self.enablePunctionGlossary("glossary", False )
            
        subnode=7
        for k in range(subnode):
            showCount=showCount+1
            checkedValue=self.set_checked_value(showCount, errorlist, lst5)
        
        showCount=showCount+1
        variableEnableValue=lst5[showCount]
        errorObject= errorlist[showCount]
        if variableEnableValue=='False':
            errorObject.setChecked(False)
            self.ui.cbxVariable.setDisabled(True)
        else: 
            errorObject.setChecked(True)
            k=-1
            varibaleList=[]       
            varibaleList=self.set_Variable_list()
            for i in varibaleList:
                k=k+1
                if i==variableEnableValue:
                    break
            self.ui.cbxVariable.setCurrentIndex(k)
        
        showCount=showCount+1
        AccleratorEnableValue=self.set_checked_value(showCount, errorlist, lst5)
        user=World.settings.value("UserDefineAccelerator").toString()
        
        showCount=showCount+1
        if AccleratorEnableValue!='False':
            self.ui.cbxAccelerator.setEnabled(True)
            self.ui.leAccelerator.setEnabled(True)
            accleratorProgram=lst5[showCount]
            errorObject= errorlist[showCount]
            k=-1
            accList=[]       
            accList=self.set_Accelerator_list()
            for i in accList:
                k=k+1
                if i==accleratorProgram:
                    break
            errorObject.setCurrentIndex(k)
            showCount=showCount+1
            errorObject= errorlist[showCount]
            if k==4:
                user=World.settings.value("UserDefineAccelerator").toString()
                errorObject.setText(user)
            else:
                accValue=self.accValue[k]
                errorObject.setText(accValue)
        else:
            showCount=showCount+1
            self.ui.cbxAccelerator.setEnabled(False)
            self.ui.leAccelerator.setEnabled(False)
        
        showCount=showCount+1
        punctuationEnableValue=self.set_checked_value(showCount, errorlist, lst5)
        if punctuationEnableValue!='False':
            self.enablePunctionGlossary("punctuation", True )

            count=7
            for i in range(count):
                showCount=showCount+1
                checkvalue=lst5[showCount]
                errorObject= errorlist[showCount]
                errorObject.setText(checkvalue)
                
        else:    
            showCount=showCount+7
            self.enablePunctionGlossary("punctuation", False ) 

        subnode=2
        for k in range(subnode):
            showCount=showCount+1
            checkedValue=self.set_checked_value(showCount, errorlist, lst5)
            
    def load_file(self, filepath):
        #open the active xml file
        try:
            abs=os.path.abspath(filepath)
        except:
            pass
        tagValueList=[]
        xmlfile = QtCore.QFile(filepath)
        doc = QtXml.QDomDocument( "ErrorChecking" );
        if xmlfile.open(QtCore.QIODevice.ReadWrite | QtCore.QIODevice.Text) == 0:
            print "cannot open file load file"
        if doc.setContent( xmlfile ) == 0:
           xmlfile.close()
        xmlfile.close()
#        file = open(filepath, "r")
        root = doc.documentElement()
        n = root.firstChild()
        e = n.toElement()
        m = e.firstChildElement()
        tag= m.tagName()
        while m.isNull() == 0:
            m = m.toElement()
            tagname=m.tagName()
            p=m.text()
            tagValueList.append(m.text())
            m = m.nextSibling()
        return tagValueList

    def striplangcontryname(self, languageObject,  countryobject):
        # gets only the language_country code from the language and country combox boxes items
        currentList=[]
        currentLanguage=str(languageObject)
#        currentLanguage=str(self.ui.cbxLanguageCode.currentText())
        currentList=self.setCountryLanguage(currentLanguage)
        languagecode=re.sub("\]|\[", "", currentList[0])      
        currentList=[]
        country= str(countryobject)
        currentList=self.setCountryLanguage(country)
        countrycode=re.sub("\]|\[", "", currentList[0])                                 
        if currentLanguage=="No country specified":
            World.settings.setValue("personalcountryLanguageCode", QtCore.QVariant(languagecode))   
        else:
            languagecode=languagecode + "_" + countrycode
            World.settings.setValue("personalcountryLanguageCode", QtCore.QVariant(languagecode))   
        return languagecode
        
    def loadActiveLanguageCountry(self):
        #reflect the changes of settings in the ui for active language and country.	
        currentLanguage=str(self.ui.cbxLanguage.currentText())
        currentList=self.setCountryLanguage(currentLanguage)
        languagecodeLevel=currentList[0].replace("]", "")
        languagecode=languagecodeLevel.replace("[", "")
        
        currentCountry=str(self.ui.cbxCountry.currentText())
        currentList=self.setCountryLanguage(currentCountry)
        countrycodeLevel=currentList[0].replace("[", "")
        countrycode=countrycodeLevel.replace("]", "")

        if currentCountry=="No country specified":
            self.filename=languagecode + "_tests.xml"
        else:
            self.filename=languagecode + "_" + countrycode + "_tests.xml"
                
        #        self.filePath= os.path.abspath(localpath + "../test_files/" + self.filename)
        self.filePath = os.path.abspath(homePath + self.filename)
        tagValueList=[]
        try:
            tagValueList=self.load_file(self.filePath)
            self.set_value(tagValueList)
            file.close()
        except:
            if not tagValueList:
                self.setAddNewLang()
            pass                                       

    def loadCountryForError(self, code):
        #reflect the changes of settings in the ui when a country is selected from the combo box.
        currentList=[]
        code=str(code)
        currentList=self.setCountryLanguage(code)
        countrycodeLevel=currentList[0].replace("[", "")
        countrycode=countrycodeLevel.replace("]", "")                                   
        countryname= currentList[1]
        currentList=[]
        language= str(self.ui.cbxLanguage.currentText())
        currentList=self.setCountryLanguage(language)
        languagecodeLevel=currentList[0].replace("]", "")
        languagecode=languagecodeLevel.replace("[", "")
        languagename= currentList[1]                                       
        if code=="No country specified":
            self.levelString=languagename + " " + "["+ languagecode  + "]"
            self.filename=languagecode + "_tests.xml"
            self.country="None"
        else:
            self.levelString=languagename + " " + "(" + countryname + ")" + " " + languagecodeLevel + "_" + countrycodeLevel
            self.filename=languagecode + "_" + countrycode + "_tests.xml"
            self.country=countrycode
        levelString=unicode(self.levelString)    
        self.ui.lbcode.setText(levelString)   

        #        self.filePath= os.path.abspath(localpath + "../test_files/" + self.filename)
        self.filePath = os.path.abspath(homePath + self.filename)
        World.settings.setValue("selfCountry", QtCore.QVariant(self.country))
        
        tagValueList=[]
        try:
            tagValueList=self.load_file(self.filePath)
            self.set_value(tagValueList)
            file.close()
        except:
            if not tagValueList:
                self.setAddNewLang()
            pass

    def loadLanguageForError(self, languageCode):
        #reflect the changes of settings in the ui when a langugae is selected from the combo box.
        if languageCode=="More Languages":
            self.load_language_ISO3(self.ui.cbxLanguage)
            self.load_language_ISO3(self.ui.cbxLanguageCode)
            self.MoreLanguageFlag=1
        else:    
            currentList=[]
            lst = []
            code=str(languageCode)
            currentList=self.setCountryLanguage(code)
            languagecodeLevel=currentList[0].replace("]", "")
            languagecode=languagecodeLevel.replace("[", "")
            languagename= currentList[1]
            currentList=[]
            country= str(self.ui.cbxCountry.currentText())
            currentList=self.setCountryLanguage(country)
            countrycodeLevel=currentList[0].replace("[", "")
            countrycode=countrycodeLevel.replace("]", "")  
            countryname= currentList[1]
            
            if country =="No country specified":
                self.levelString=languagename + " " +  "[" + languagecode  + "]"
                self.filename=languagecode + "_tests.xml"
            else:                
                self.levelString=languagename + " " + "(" + countryname + ")" + " " + languagecodeLevel + "_" + countrycodeLevel
                self.filename=languagecode + "_" + countrycode + "_tests.xml"
                
            #        self.filePath= localpath + "../test_files/" + self.filename
            self.filePath = homePath + self.filename

            levelString=unicode(self.levelString) 
            self.ui.lbcode.setText(levelString)
            self.language=languagecode
            World.settings.setValue("selfLanguage", QtCore.QVariant(self.language))
            
            tagValueList=[]
            try:
                tagValueList=self.load_file(self.filePath)
                self.set_value(tagValueList)
                file.close()
                
            except:
                if not tagValueList:
                    self.setAddNewLang()
                pass
                
    def checkfileLanguage(self, path, purpose=""):
        #gets the translation language of the a file
        self.purpose=purpose
        path=str(path)
        prolangcur=""
        if (path.endswith(".xlf") or path.endswith(".xliff")):
            sourceTree= etree.parse(path)
            root = sourceTree.getroot()
            self.fileNode = root[0]
            prolangcur=self.fileNode.get('target-language')
        if (path.endswith(".po")):
            self.postore = factory.getobject(path)  
            self.headerpo = self.postore.header()
            if self.headerpo:
                self.currentpoheaderDic = self.postore.parseheader()        
                if ("X-Language" in self.currentpoheaderDic.keys()):
                        if self.currentpoheaderDic["X-Language"]:
                            prolangcur=self.currentpoheaderDic["X-Language"]                   
        self.filelangcur=prolangcur                            
        if purpose=="newproject":                    
            if not prolangcur:
                self.fileswithnolanguage.append(path)
            elif globalClass.projectlanguage!=prolangcur:
                    self.fileswithdifflanguage.append(path)
        if purpose=="TM":                    
            if not prolangcur:
                self.fileswithnolanguage.append(path)
            elif globalClass.TMGLStargetLanguageCode!=prolangcur:
                self.fileswithdifflanguage.append(path) 
        return self.filelangcur  
                
    def LoadAcceleratorSymbol(self, current):
        #accelerator symbol
        user=''
        acceleratorValuelist=self.set_acceleratorValue_list()
        if current == "openoffice":
            self.ui.leAccelerator.setText("~")
        if current == "Mozilla" or current == "KDE":
            self.ui.leAccelerator.setText("&")
        if current == "Gnome":
            self.ui.leAccelerator.setText("_")    
        if current =="UserDefine":
            user=World.settings.value("UserDefineAccelerator").toString()
            self.ui.leAccelerator.setText(user)
            
        
    def setCountryLanguage(self, current):
        self.currentList=[]
        currenlst=[]
        currenlst=current.split(' ')
        countrycode=currenlst[-1]
        self.currentList.append(countrycode)
        countryname=''
        for i in currenlst:
            count=len(currenlst)
            if i!=countrycode:
                countryname+= i
                if(count>2):
                    countryname +=' '
        self.currentList.append(countryname)
        return self.currentList
     
#                
    # Personalize page
    def setCountryIndex(self, cntryCode):
        #Set country name in line edit widget corresponding to cntryCode.
        currentList=[]
        Code=str(cntryCode)
        currentList=self.setCountryLanguage(Code)
        countrycodeLevel=currentList[0].replace("[", "")
        countrycode=countrycodeLevel.replace("]", "")                                   
        countryname= currentList[1]
        currentList=[]
        language= str(self.ui.cbxLanguageCode.currentText())
        currentList=self.setCountryLanguage(language)
        languagecodeLevel=currentList[0].replace("]", "")
        languagecode=languagecodeLevel.replace("[", "")
        languagename= currentList[1]                                       
        if cntryCode=="No country specified":
            levelString=languagename + " " + "["+ languagecode  + "]"
        else:
            levelString=languagename + " " + "(" + countryname + ")" + " " + languagecodeLevel + "_" + countrycodeLevel
        levelString=unicode(levelString)    
        self.ui.lbLangCntry.setText(levelString)
        
    def setLanguageIndex(self, langCode):
        """Set language name in line edit widget corresponding to langCode.
        @param langCode: a language code for finding language name as Qstring type. """

#        language = common.Common(str(langCode))
#        self.ui.lineFullLang.setText(language.fullname)
        if langCode=="More Languages":
            self.load_language_ISO3(self.ui.cbxLanguage)
            self.load_language_ISO3(self.ui.cbxLanguageCode)
#            self.MoreLanguageFlag=1
        else:    
            currentList=[]
            lst = []
            code=str(langCode)
            currentList=self.setCountryLanguage(code)
            languagecodeLevel=currentList[0].replace("]", "")
            languagecode=languagecodeLevel.replace("[", "")
            languagename= currentList[1]
            currentList=[]
            country= str(self.ui.cbxCountryCode.currentText())
            currentList=self.setCountryLanguage(country)
            countrycodeLevel=currentList[0].replace("[", "")
            countrycode=countrycodeLevel.replace("]", "")  
            countryname= currentList[1]
            
            if country =="No country specified":
                levelString=languagename + " " + "[" + languagecode  + "]"
            else:                
                levelString=languagename + " " + "(" + countryname + ")" + " " + languagecodeLevel + "_" + countrycodeLevel
            levelString=unicode(levelString)
            self.ui.lbLangCntry.setText(levelString)
    
    def setcurrentItem(self, comboobject, checkvalue, typeofvalue=""):
        # set the current items of the combo boxes  
        langIndex=0
        for index in range(comboobject.count()):
            if checkvalue in comboobject.itemText(index):
                if typeofvalue=="target":
                    comboobject.setCurrentIndex(langIndex)
                break
            langIndex=langIndex+1
    
    def check_plural_expression_changes(self):
        # checks if user changes plural expression for a perticular language. 
        list=[]
        plural_changes=False
        language= str(self.ui.cbxLanguageCode.currentText())
        langCode=re.findall(r'\[.*\]', language)[0]
        Code=langCode.replace("]", "")  
        langCode=unicode(Code.replace("[", ""))
        number_of_plural=self.ui.spinBox.value()
        Current_plural_expression=unicode(self.ui.lineEqaution.text())
        for key in self.plural_ExpressionDict.keys():
            if key==unicode(langCode):
                plural_info =self.plural_ExpressionDict[key]
                list=plural_info.split(",")
                break
        if list:
            if not (int(number_of_plural)==int(list[1])) or not ((Current_plural_expression)==list[2]): 
                plural_changes=True
        if plural_changes:
            plural_expression_file = os.path.abspath(homePath + "plural_expression")
            fp = open(plural_expression_file, 'w')
            dictvalue= "'"  +  unicode(langCode) + "':" + list[0] +", " + unicode(number_of_plural) + " ,' " + unicode(Current_plural_expression) + "')," + "\n"
            finalDict={}
            for key in self.plural_ExpressionDict.keys():
                if key==unicode(langCode):
                    finalDict[key] = dictvalue    
                else:    
                    finalDict[key]="'"  +  key + "':" +self.plural_ExpressionDict[key] + "," + "\n"

            for key in finalDict.keys(): 
                fp.write(finalDict[key])
            fp.close() 
        self.plural_ExpressionDict={}        
        
    def copy_plural_file(self):
        # This function tests whether the test_file directory exists in the wordforge config folder. If it is not in there then creates the folder and copy the test_files from installation directory into this folder.
        if (os.name == 'posix') :
            localpath = os.path.split(os.path.realpath( __file__ ))[0] + os.path.sep
        else:
            localpath = ""
#        targetDir = os.path.join(os.path.expanduser("~"), World.logDir, 'test_files') 
        #copy plural_expression in test_files dir in .config or application data
        targetDir = os.path.join(World.configDir, 'test_files')  
        if (os.name == 'posix') :
            sourceDir = os.path.abspath(localpath + '..' + os.path.sep + 'test_files'+os.path.sep +'plural_expression')
        else:
            sourceDir = os.path.abspath(os.path.dirname(sys.argv[0]) +os.path.sep   + '..' + os.path.sep + 'test_files'+os.path.sep +'plural_expression')    
        import shutil
#        sourceDir = os.path.abspath(os.path.dirname(sys.argv[0]) +os.path.sep   + '..' + os.path.sep + 'test_files'+os.path.sep +'plural_expression')
#        sourceDir = os.path.abspath(localpath + '..' + os.path.sep + 'test_files')
        shutil.copy2(sourceDir, targetDir)
#        import distutils.dir_util      
#        sourceDir = os.path.abspath(localpath + '..' + os.path.sep + 'test_files')
#        distutils.dir_util.copy_tree(sourceDir, targetDir)   
        
    def load_plural_expression(self):  
        self.plural_ExpressionDict={}    
        plural_expression_file = os.path.abspath(homePath + "plural_expression")
        self.plural_expression=[]
        if (not os.path.exists(plural_expression_file)):
            self.copy_plural_file()
        fp = open(plural_expression_file)
        
        plural_expression = fp.readlines()
        for expr in plural_expression:
            fileLine=expr[:-2]
            fileLine=unicode(fileLine)
            getlangcode=fileLine.split("':")
            langCode=getlangcode[0].replace("'", "")
            self.plural_ExpressionDict[langCode]=getlangcode[1]  

    def setNPlural(self, langCode):
        """Set nplurals for specific language.
        @param langCode: as Qstring type. """
        langCode=langCode[-3:]
        langCode=langCode.replace("]", "")  
        if str(langCode) in self.plural_ExpressionDict.keys():    
            language = self.plural_ExpressionDict[str(langCode)]
            expression=language.split(",")
            self.ui.spinBox.setValue(int(expression[1]))
            expression=expression[2][2:-2]
            self.ui.lineEqaution.setText(expression)
    
    def changedPaged(self):
        '''show a page of stackedWidget according to selected item in listwidget.
        '''
        self.ui.stackedWidget.setCurrentIndex(self.ui.listWidget.currentRow())
     
    def setGlossaryEnable(self):
        # enables and disables the fields under glossay
        checked = self.sender().isChecked()
        if (checked):
            self.ui.leGeneral.setEnabled(True)
            self.ui.leNones.setEnabled(True)
            self.ui.leVerbs.setEnabled(True)
            self.ui.leAdjectives.setEnabled(True)
        else:
            self.ui.leGeneral.setEnabled(False)
            self.ui.leNones.setEnabled(False)
            self.ui.leVerbs.setEnabled(False)
            self.ui.leAdjectives.setEnabled(False)
            
            
    def setPunctuationEnable(self):
        # enables and disables the fields under punctuations
        checked = self.sender().isChecked()
        if (checked):
            self.ui.leFullStop.setEnabled(True)
            self.ui.leQuestionMark.setEnabled(True)
            self.ui.leExcla.setEnabled(True)
            self.ui.leSemiColon.setEnabled(True)
            self.ui.leColon.setEnabled(True)
            self.ui.leElipsis.setEnabled(True)
            self.ui.leComma.setEnabled(True)
        else:
            self.ui.leFullStop.setEnabled(False)
            self.ui.leQuestionMark.setEnabled(False)
            self.ui.leExcla.setEnabled(False)
            self.ui.leSemiColon.setEnabled(False)
            self.ui.leColon.setEnabled(False)
            self.ui.leElipsis.setEnabled(False)
            self.ui.leComma.setEnabled(False)
        
    def setAccelerator(self):
        # enables and disables the fields under Accelerator
        checked = self.sender().isChecked()
        if (checked):
            self.ui.cbxAccelerator.setEnabled(True)
            self.ui.leAccelerator.setEnabled(True)
        else:
            self.ui.cbxAccelerator.setEnabled(False)  
            self.ui.leAccelerator.setEnabled(False)
    
    def setVariable(self):
        # enables and disables the fields under variables
        checked = self.sender().isChecked()
        if (checked):
            self.ui.cbxVariable.setEnabled(True)
        else:
            self.ui.cbxVariable.setEnabled(False)
    
    def setIntervalTimer(self):
        checked = self.sender().isChecked()
        if (checked):
            self.ui.QSpinBoxAutoSave.setEnabled(True)
        else:
            self.ui.QSpinBoxAutoSave.setEnabled(False)
    
    
    def copyTarget(self, value):
        self.ui.lblMax.setText("and " + str(value) + "%")
        
    def detectMin(self, min):
        """
        min cannot be greater than or equal to max.
        """
        max = self.ui.spnTarget.value()
        if (max <= min):
            max = min + 1
            self.ui.spnTarget.setValue(max)
            
    def detectMax(self, max):
        """
        max cannot be lesser than or equal min.
        """
        min = self.ui.spnMin.value()
        if (min >= max):
            min = max -1
            self.ui.spnMin.setValue(min)
        
    def setGlossaryOptions(self):
        #        chnage the glossary highlight state if needed
        previousState = World.settings.value("GlossaryPreference",  QtCore.QVariant(True)).toBool()
        currentState = self.ui.chbAutoIdentTerm.isChecked()
#        Used xor. an important xor property is true^true = False. If same values are xored then result is always False. If different values are xored then the result is True that is True^False = True. 
# Now calling glossary highlight function.
        if previousState^currentState and self.parent.operator.__termMatcher__:
                self.parent.dockTUview.setHighlightGlossary(currentState)
        else:
                self.parent.dockTUview.setHighlightGlossary(False)
        return currentState
        
    def loadDictionaries(self, dicName = None):
        """
        show available dictionaries found in WordForge dictionary path
        """
        dicPath = os.path.abspath(localpath + ".." + os.path.sep + "dict") + os.path.sep
        dict_languages = World.dict_languages
        state = QtCore.Qt.ItemIsSelectable | QtCore.Qt.ItemIsEnabled
        center = QtCore.Qt.AlignHCenter + QtCore.Qt.AlignVCenter
        
        row = 0
        # add dictionary to tableSpellCheck
        if (dicName):
            row = self.ui.tableSpellCheck.rowCount()
            self.ui.tableSpellCheck.setRowCount(row + 1)
            # Active column
            temActive = QtGui.QTableWidgetItem()
            temActive.setFlags(state)
            temActive.setTextAlignment(center)
            self.ui.tableSpellCheck.setItem(row, 0, temActive)

            fullLang = self.getFullLang(dicName)
            if (fullLang):
                # Language column
                itemFullLanguage = QtGui.QTableWidgetItem(fullLang)
                itemFullLanguage.setFlags(state)
                self.ui.tableSpellCheck.setItem(row, 1, itemFullLanguage)
            # Dictionary column
            itemDict = QtGui.QTableWidgetItem(dicName)
            itemDict.setFlags(state)
            itemDict.setTextAlignment(center)
            self.ui.tableSpellCheck.setItem(row, 2, itemDict)
            return
        
        # load dictionaries from WordForge dictionary path

        row = 0

        files = enchant.list_languages()
        
        for file in files:
            self.ui.tableSpellCheck.setRowCount(row + 1)
            # Active column
            temActive = QtGui.QTableWidgetItem()
            temActive.setFlags(state)
            temActive.setTextAlignment(center)
            self.ui.tableSpellCheck.setItem(row, 0, temActive)
            
            fullLang = self.getFullLang(file)
            if (fullLang):
                # Language column
                itemFullLanguage = QtGui.QTableWidgetItem(fullLang)
                itemFullLanguage.setFlags(state)
                self.ui.tableSpellCheck.setItem(row, 1, itemFullLanguage)
            # Dictionary column

            itemDict = QtGui.QTableWidgetItem(file)
            itemDict.setFlags(state)
            itemDict.setTextAlignment(center)
            self.ui.tableSpellCheck.setItem(row, 2, itemDict)
            row += 1
            # do not find files in sub folder
        self.ui.tableSpellCheck.sortItems(1)
        dictionary = World.settings.value("CurrentLanguage").toString()
        if (dictionary):
            # if remembered dictionary exists, use it
            self.setDefaultDict(dictionary)
                    
    def setDefaultDict(self, para):
        """
        set default dictionary
        @param para: type as QString
        """
        item = self.ui.tableSpellCheck.findItems(para, QtCore.Qt.MatchExactly)
        if (item):
            row = self.ui.tableSpellCheck.row(item[0])
            self.ui.tableSpellCheck.selectRow(row)
            self.setActiveDictionary(para,self.ui.tableSpellCheck, 0)
        else:
            self.ui.currentIndex = -1
            self.__activeDictionary__ = ''
            return

    def getFullLang(self, dic):
        """
        getting full language name through dictionary
        @param dic: type as string
        """
        langName = countryName = None
        lang_Country_List = dic.split("_")
        if len(lang_Country_List)<3:
            if len(lang_Country_List[0]) == 3 and not self.iso3List:
                self.load_language_ISO3(self.ui.cbxLanguage)
                self.load_language_ISO3(self.ui.cbxLanguageCode)
            if len(lang_Country_List[0]) == 2:
                langName = self.getLangOrCountry(self.List, lang_Country_List[0])
            elif len(lang_Country_List[0]) == 3:
                langName = self.getLangOrCountry(self.iso3List, lang_Country_List[0])
            if len(lang_Country_List)== 1:
                countryName = ' '
            elif len(lang_Country_List)== 2:
                countryName = self.getLangOrCountry(self.countryList, lang_Country_List[1])
            if langName and countryName:
                return langName + ' (' + countryName + ')'
            else:
                return None
        elif len(lang_Country_List)>2:
            if len(lang_Country_List[1]) == 3 and not self.iso3List:
                self.load_language_ISO3(self.ui.cbxLanguage)
                self.load_language_ISO3(self.ui.cbxLanguageCode)
            if len(lang_Country_List[1]) == 2:
                langName = self.getLangOrCountry(self.List, lang_Country_List[1])
            elif len(lang_Country_List[1]) == 3:
                langName = self.getLangOrCountry(self.iso3List, lang_Country_List[1])
            country=lang_Country_List[2].replace(".dat", "")
            country=country.replace(".idx", "")
            countryName = self.getLangOrCountry(self.countryList, country)
            if langName and countryName:
                return langName + ' (' + countryName + ')'
            else:
                return None        
     
    def getLangOrCountry(self, searchList, searchValue ):
#      searchList is the languageList or the countrylist in which we search whether a particular value (here searchValue) exist or not. 
        for each in searchList:
            try:
                if '[' + searchValue + ']' == each.split()[-1]:
                    return each.rsplit(' ', 1)[0]
            except:
                pass
        return None
    
    def searchActiveDictionary(self, dict):
        files = enchant.list_languages()
        for file in files:
            if file== dict:
                    return True
        return False    
    
    def setActiveDictionary(self, dict, tableobject, column):
        '''
        Get the dictionary name from item at curren row and column 2, and set it to use for spellcheck.
        Set "In Use" to column 0 of the current row.
        '''
        for row in range(tableobject.rowCount()):
            tableobject.item(row, 0).setText("")
        currentRow = tableobject.currentRow()
        item = tableobject.item(currentRow, 2)
        if (item and item.isSelected()):
#            tableobject.item(currentRow, 0).setText((self.tr("In use")))
            tableobject.item(currentRow, column).setText(u"\u221a")
            if tableobject==self.ui.tableSpellCheck:
                self.__activeDictionary__ = item.text().__str__()
            row = currentRow
                
    def addDictionary(self):
        """
        Open a dialog box and add dictionary for spellchecker, files will be copied to WordForge dictionary path.
        """
        directory = World.settings.value("workingDir").toString()
        filenames = QtGui.QFileDialog.getOpenFileNames(self, self.tr("Select Dictionary Files"),
                        directory, "Files (*.dic *.aff *.zip *.tar*)")
        if platform.system() == "Linux":
            dictDirPath = os.path.expanduser('~') + '/.config/enchant/myspell'
            if not os.path.exists(dictDirPath):
                os.makedirs(dictDirPath)
            dicPath = dictDirPath + os.path.sep

        elif platform.system() == "Windows":
            dictDirPath = os.path.expanduser('~') + '\Application Data\enchant\myspell'
            if not os.path.exists(dictDirPath):
                os.makedirs(dictDirPath)
            dicPath = dictDirPath + os.path.sep
                
        if debug: print u"· Preference.addDictionary - dicPath: ", dicPath  
        if filenames:
            import zipfile
            import tarfile
            import shutil
            
            directory = os.path.dirname(str(filenames[0]))
            World.settings.setValue("workingDir", QtCore.QVariant(directory))
            
            fileIsValid = False
            for filename in filenames:
                filename = str(filename)
                basename = os.path.basename(filename)
#                basenameNoExt = basename[0:basename.rfind(".")]
                basenameNoExt = basename.split(".")[0]
                path = os.path.dirname(filename) + os.path.sep
                
                # handle zip file
                if zipfile.is_zipfile(filename):
                    zipfileobj = zipfile.ZipFile(filename, 'r')
                    # TODO: think about character case
                    if (basenameNoExt + ".dic") and (basenameNoExt + ".aff") in zipfileobj.namelist():
                        for name in zipfileobj.namelist():
                            content = zipfileobj.read(name)
                            fileIsValid = True
                            try:
                                file = open(dicPath + name, "w")
                                file.writelines(content)
                                file.close()
                            except:
                                fileIsValid = False
                                break
                    zipfileobj.close()
                
                # handle tar.gz file.
                elif tarfile.is_tarfile(filename):
                    archive = tarfile.open(filename, 'r:')
                    # TODO: think about character case
                    if (basenameNoExt + ".dic") and (basenameNoExt + ".aff") in archive.getnames():
                        fileIsValid = True
                        for member in archive.getmembers():
                            content = archive.extractfile(member)
                            try:
                                file = open(dicPath + member.name, "w")
                                file.writelines(content)
                                file.close()
                            except:
                                fileIsValid = False
                                break
                    archive.close()
                    
                # selected files is .dic or .aff or both
                else:
                    # check if both types of file exist, copy only if they are.
                    if (filename.endswith(".dic") or filename.endswith(".aff")) and \
                        (os.path.exists(path + basenameNoExt + ".dic") and os.path.exists(path + basenameNoExt + ".aff")):
                        fileIsValid = True
                        try:
                            shutil.copyfile(path + basenameNoExt + ".dic", dicPath + basenameNoExt + ".dic")
                            shutil.copyfile(path + basenameNoExt + ".aff", dicPath + basenameNoExt + ".aff")
                        except:
                            fileIsValid = False
            if debug: print u"· Preference.addDictionary - basenameNoExt: ", basenameNoExt
            if (fileIsValid):
                self.loadDictionaries(basenameNoExt)
            else:
                result = QtGui.QMessageBox.critical(self, self.tr("Spellcheck"),
                    self.tr("Dictionary could not be added. This is due to the file(s) selected is not valid or it is not sufficient."),
                    QtGui.QMessageBox.Ok | QtGui.QMessageBox.Default)
    
    def deleteDictionary(self):
        """
        Remove a selected dictionary entry from the spellcheck table.
        Delete .aff and .dic in WordForge dictionary path..
        """
        currentRow = self.ui.tableSpellCheck.currentRow()
        item = self.ui.tableSpellCheck.item(currentRow, 2)
        if (item and item.isSelected()):
            basenameNoExt = item.text().__str__()
            if platform.system() == "Linux":
                dicPath = os.path.expanduser('~') + '/.config/enchant/myspell/'

            elif platform.system() == "Windows":
                dicPath = os.path.expanduser('~') + '\Application Data\enchant\myspell' + os.path.sep

            try:
                os.remove(dicPath + basenameNoExt + ".dic")
                os.remove(dicPath + basenameNoExt + ".aff")
            except:
                if platform.system() == "Linux":
                    errorMessage = 'This dictionary is not in your home directory. You can delete dictionaries that are only in your ~/.config/enchant/myspell directory.'

                elif platform.system() == "Windows":
                    errorMessage = 'This dictionary is not in your home directory. You can delete dictionaries that are only in your ~\Application Data\enchant\myspell directory.'

                QtGui.QMessageBox.critical(self, 'Error', errorMessage)
                return
            self.ui.tableSpellCheck.removeRow(currentRow)
            if (basenameNoExt == self.__activeDictionary__):
                self.__activeDictionary__ = ""
    
    def deleteThesaurus(self):
        """
        Remove a selected thesaurus entry from the Thesaurus table.
        Delete .aff and .dic in WordForge dictionary path..
        """
        currentRow = self.ui.tableThesaurus.currentRow()
        item = self.ui.tableThesaurus.item(currentRow, 3)
        if (item and item.isSelected()):
            basenameNoExt = item.text().__str__()
            if platform.system() == "Linux":
                dicPath = os.path.expanduser('~') + '/.config/WordForge/myThesaurus' + os.path.sep

            elif platform.system() == "Windows":
                dicPath = os.path.expanduser('~') + '\Application Data\WordForge/myThesaurus' + os.path.sep

            try:
                os.remove(dicPath + basenameNoExt + ".dat")
                os.remove(dicPath + basenameNoExt + ".idx")
            except:
                if platform.system() == "Linux":
                    errorMessage = 'This Thesaurus is not in your home directory. You can delete dictionaries that are only in your ~/.config/WordForge/myThesaurus directory.'

                elif platform.system() == "Windows":
                    errorMessage = 'This dictionary is not in your home directory. You can delete dictionaries that are only in your ~\Application Data\WordForge/myThesaurus directory.'

                QtGui.QMessageBox.critical(self, 'Error', errorMessage)
                return
                
            self.ui.tableThesaurus.removeRow(currentRow)
            if basenameNoExt==str(World.settings.value("sourceThesFile").toString()):
                World.settings.setValue("sourceThesFile", QtCore.QVariant(""))
            elif basenameNoExt==str(World.settings.value("targetThesFile").toString()):
                World.settings.setValue("targetThesFile", QtCore.QVariant(""))    
                
    def loadThesaurus(self, dicName = None):
        """
        show available Thesaurus found in WordForge thesaurus path
        """
        state = QtCore.Qt.ItemIsSelectable | QtCore.Qt.ItemIsEnabled
        center = QtCore.Qt.AlignHCenter + QtCore.Qt.AlignVCenter
        
        row = 0
        # add dictionary to ThesaurusTable 
        if (dicName):
            row = self.ui.tableThesaurus.rowCount()
            self.ui.tableThesaurus.setRowCount(row + 1)
            # Active source column
            temActive = QtGui.QTableWidgetItem()
            temActive.setFlags(state)
            temActive.setTextAlignment(center)
            self.ui.tableThesaurus.setItem(row, 0, temActive)
            
            # Active target column
            temActive = QtGui.QTableWidgetItem()
            temActive.setFlags(state)
            temActive.setTextAlignment(center)
            self.ui.tableThesaurus.setItem(row, 1, temActive)
            
            fullLang = self.getFullLang(dicName)
            if (fullLang):
                # Language column
                itemFullLanguage = QtGui.QTableWidgetItem(fullLang)
                itemFullLanguage.setFlags(state)
                self.ui.tableThesaurus.setItem(row, 2, itemFullLanguage)
            # Thesaurus column
            itemDict = QtGui.QTableWidgetItem(dicName)
            itemDict.setFlags(state)
            itemDict.setTextAlignment(center)
            self.ui.tableThesaurus.setItem(row, 3, itemDict)
            return
        
        # load dictionaries from WordForge thesaurus path
        row = 0
        files = self.add_Thesaurus_in_table()
        if files:
            for file in files:
                self.ui.tableThesaurus.setRowCount(row + 1)
                # Active source column
                temActive = QtGui.QTableWidgetItem()
                temActive.setFlags(state)
                temActive.setTextAlignment(center)
                self.ui.tableThesaurus.setItem(row, 0, temActive)
                
                # Active target column
                temActive = QtGui.QTableWidgetItem()
                temActive.setFlags(state)
                temActive.setTextAlignment(center)
                self.ui.tableThesaurus.setItem(row, 1, temActive)
                
                fullLang = self.getFullLang(file)
                if (fullLang):
                    # Language column
                    itemFullLanguage = QtGui.QTableWidgetItem(fullLang)
                    itemFullLanguage.setFlags(state)
                    self.ui.tableThesaurus.setItem(row, 2, itemFullLanguage)
                # Thesaurus column

                itemDict = QtGui.QTableWidgetItem(file)
                itemDict.setFlags(state)
                itemDict.setTextAlignment(center)
                self.ui.tableThesaurus.setItem(row, 3, itemDict)
                row += 1
            # do not find files in sub folder
        self.ui.tableSpellCheck.sortItems(1)
        dictionary = str(World.settings.value("CurrentLanguage").toString())
        if dictionary and files:
            for file in files:
                if dictionary in file:
                    self.setDefaultThes(file, 1)             
        if self.parent.operator.sourcelang and files:
            for file in files:
                if self.parent.operator.sourcelang in file:
                    self.setDefaultThes(file, 0)  
                    
    def setDefaultThes(self, thesfile, column):
        # set default thesaurus file for source and target
        item = self.ui.tableThesaurus.findItems(thesfile, QtCore.Qt.MatchExactly)
        if (item):
            row = self.ui.tableThesaurus.row(item[0])
            self.ui.tableThesaurus.selectRow(row)
            self.setActiveDictionary(thesfile,self.ui.tableThesaurus, column)
            if column ==0:
                World.settings.setValue("sourceThesFile", QtCore.QVariant(thesfile))  
            if column ==1:
                World.settings.setValue("targetThesFile", QtCore.QVariant(thesfile))  
        else:
            self.ui.currentIndex = -1
            return
        
    def find_language_Name(self, language_code):
        """
        Find the whole name of the language and country from language and country code.
        """
        languagecountry=language_code.split("_")
        languagecode="["+languagecountry[0]+"]"
        countrycode="["+languagecountry[1]+"]"
        filepath = os.path.abspath(homePath + "sorted_language_code")
        fp = open(filepath)
        fileList = fp.readlines()
        for fileLine in fileList:
            if languagecode in fileLine:
                languageName=fileLine.replace("\n", "")
        filepath2 = os.path.abspath(homePath + "sorted_country_code")
        fp2 = open(filepath2)
        fileList2 = fp2.readlines()
        countryName=''
        for fileLine in fileList2:
            if countrycode in fileLine:
                countryName=fileLine.replace("\n", "")   
        return languageName , countryName
        
    def addThesaurus(self):
        """
        Open a dialog box and add thesaurus, files will be copied to WordForge thesaurus path.
        """
        self.thesfilenames=[]
        directory = World.settings.value("workingDir").toString()
        self.thesfilenames = QtGui.QFileDialog.getOpenFileNames(self, self.tr("Select Thesaurus Files"),
                        directory, "Files (*.idx *.dat *.zip *.tar*)")
        if platform.system() == "Linux":
            dictDirPath = os.path.expanduser('~') + '/.config/WordForge/myThesaurus'
            if not os.path.exists(dictDirPath):
                os.makedirs(dictDirPath)
            dicPath = dictDirPath + os.path.sep

        elif platform.system() == "Windows":
            dictDirPath = os.path.expanduser('~') + '\Application Data\WordForge/myThesaurus'
            if not os.path.exists(dictDirPath):
                os.makedirs(dictDirPath)
            dicPath = dictDirPath + os.path.sep            
        
        if self.thesfilenames:
            import zipfile
            import tarfile
            import shutil
            directory = os.path.dirname(str(self.thesfilenames[0]))
            World.settings.setValue("workingDir", QtCore.QVariant(directory))
            
            fileIsValid = False
            for filename in self.thesfilenames:
                filename = str(filename)
                basename = os.path.basename(filename)
#                basenameNoExt = basename[0:basename.rfind(".")]
                basenameNoExt = basename.split(".")[0]
                path = os.path.dirname(filename) + os.path.sep
                # handle zip file
                if zipfile.is_zipfile(filename):
                    zipfileobj = zipfile.ZipFile(filename, 'r')
                    # TODO: think about character case
                    if (basenameNoExt + ".dat") and (basenameNoExt + ".idx") in zipfileobj.namelist():
                        for name in zipfileobj.namelist():
                            content = zipfileobj.read(name)
                            fileIsValid = True
                            try:
                                file = open(dicPath + name, "w")
                                file.writelines(content)
                                file.close()
                            except:
                                fileIsValid = False
                                break
                    zipfileobj.close()
                
                # handle tar.gz file.
                elif tarfile.is_tarfile(filename):
                    archive = tarfile.open(filename, 'r:')
                    # TODO: think about character case
                    if (basenameNoExt + ".dat") and (basenameNoExt + ".idx") in archive.getnames():
                        fileIsValid = True
                        for member in archive.getmembers():
                            content = archive.extractfile(member)
                            try:
                                file = open(dicPath + member.name, "w")
                                file.writelines(content)
                                file.close()
                            except:
                                fileIsValid = False
                                break
                    archive.close()
                # selected files is .dic or .aff or both
                else:
                    # check if both types of file exist, copy only if they are.
                    if (filename.endswith(".dat") or filename.endswith(".idx")) and \
                        (os.path.exists(path + basenameNoExt + ".dat") and os.path.exists(path + basenameNoExt + ".idx")):
                        fileIsValid = True
                        try:
                            shutil.copyfile(path + basenameNoExt + ".dat", dicPath + basenameNoExt + ".dat")
                            shutil.copyfile(path + basenameNoExt + ".idx", dicPath + basenameNoExt + ".idx")
                        except:
                            fileIsValid = False
            if (fileIsValid):     
                self.loadThesaurus(basenameNoExt)           
            if (not fileIsValid):
                result = QtGui.QMessageBox.critical(self, self.tr("Thesaurus"),
                    self.tr("Thesaurus could not be added. This is due to the file(s) selected is not valid or it is not sufficient."),
                    QtGui.QMessageBox.Ok | QtGui.QMessageBox.Default)  
       
        if self.thesfilenames:            
            if self.sender()==self.ui.ChooseThesSource:            
                   self.ui.sourceThesFile.setText(self.thesfilenames[0])   
            if self.sender()==self.ui.ChooseThesTarget:            
                   self.ui.targetThesFile.setText(self.thesfilenames[0])     
            
    def goDownload(self):
        """
        go to a website to downloadMaxSuggestions
        """
        import webbrowser
        webbrowser.open_new(World.dictionary_url)
        return

    def changeFuzzyCheckbox(self, state):
        """
        change the status of "markAsFuzzy" checkbox
        """
        if(state):
            self.ui.chbMarkStringAsFuzzy.setEnabled(True)
            self.ui.chbMarkStringAsFuzzy.setChecked(True)
        else:
            self.ui.chbMarkStringAsFuzzy.setEnabled(False)
            self.ui.chbMarkStringAsFuzzy.setChecked(False)


if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    user = Preference(None)
    user.showDialog()
    sys.exit(app.exec_())
