#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
# Copyright 2005, 2006 Zuza Software Foundation
# Copyright 2009 WordForge Foundation
# This file is part of WordForge Editor
#
# WordForge Editor is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# WordForge Editor is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with translate; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

"""convert from internal translation memory to a TMX (Translation Memory eXchange) file"""


from WordForge.translate.storage import tmx
import os

# class tm2tmx:
def convertTM2tmx(aMatcher, targetFile, sourcelanguage="en", targetlanguage=None):
    """converts internal TM (a matcher)  to a TMX file"""
    myTMX = tmx.tmxfile()
    for inunit in aMatcher.candidates.units:
        source = inunit.source
        translation = inunit.target
        TMid = inunit.id
        myTMX.addtranslation(source, sourcelanguage, translation, targetlanguage, TMid)
    fout = open(targetFile, 'wb')
    fout.write(str(myTMX))
    fout.close()
 
