#!/usr/bin/env python
# -*- coding: utf-8 -*

#Copyright (c) 2006 - 2007 by The WordForge Foundation
#                       www.wordforgefoundation.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# See the LICENSE file for more details. 
#
# Developed by:
#       Hok Kakada (hokkakada@khmeros.info)
#       Keo Sophon (keosophon@khmeros.info)
#       San Titvirak (titvirak@khmeros.info)
#       Seth Chanratha (sethchanratha@khmeros.info)
# 
# This module is working on tests for Operator classes

import unittest
import SpellCheck
import os, sys
from PyQt4 import QtGui, QtCore

class TestSpellCheck(unittest.TestCase):
    def setUp(self):
        self.spellCheck = SpellCheck.SpellCheck(None)
        
    def testInitializeFillingResult(self):
        self.spellCheck.setVisible(True)
        self.spellCheck.initializeFillingResult(1, ['lptop', 'អាមរិកា'], [['laptop', 'lab'], ['អាមេរិកា']])
        
        self.self.assertEqual(self.spellCheck.unitIndex, 1)
        self.self.assertEqual(self.spellCheck.missSpelledList, ['lptop', 'អាមរិកា'])
        self.self.assertEqual(self.spellCheck.suggestedList, [['laptop', 'lab'], ['អាមេរិកា']])
    
    def testSetIgnoreAll(self):
        self.spellCheck.ignoreAll = ['Amrica', 'អាមរិកា']
        self.spellCheck.missSpelledList = ['lptop','Amrica', 'អាមរិកា', 'Schol']
        
        self.spellCheck.index = 1
        self.spellCheck.setIgnoreAll()
        self.assertEqual(self.spellCheck.ignoreAll, ['Amrica', 'អាមរិកា'])
        
        self.spellCheck.index = 0
        self.spellCheck.setIgnoreAll()
        self.assertEqual(self.spellCheck.ignoreAll, ['Amrica', 'អាមរិកា', 'lptop'])
        
        self.assertEqual(self.spellCheck.index, 1)
    
    
if __name__ == '__main__':
    app = QtGui.QApplication(sys.argv)
    unittest.main()
