#!/usr/bin/python
# -*- coding: utf-8 -*-
#Copyright (c) 2006 - 2007 by The WordForge Foundation
#                       www.wordforgefoundation.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2.1
# of the License, or (at your option) any later version.
#
# See the LICENSE file for more details. 
# 
# Developed by:
#       Hok Kakada (hokkakada@khmeros.info)
#       Keo Sophon (keosophon@khmeros.info)
#       San Titvirak (titvirak@khmeros.info)
#       Seth Chanratha (sethchanratha@khmeros.info)
#       Aditi Barua(aditi@ankur.org.bd)
#       Asheq Hamid(asheq@ankur.org.bd)
#       Md. Rezwan Shahid(rezwan@ankur.org.bd)
#       Goutom Roy(goutom@ankur.org.bd)
# This module stores global variables for use in whole applicaion.

from PyQt4 import QtCore
import os

# Set to True for debugging (tracing messages will be sent to standard output)
WF_debug = False

# helper constants for filtering
header = 0
fuzzy = 1
translated = 2
untranslated = 4
plural = 8
filterAll = 4 + 2 + 1

source = 1
target = 2
comment = 4

searchForward = 1
searchBackward = 2
searchStatic = 4

searchFormat = 1
glossaryFormat = 2

# this is the global settings object, use only this for saving and restoring settings

settingOrg = "WordForge"
settingApp = "WordForge"
settings = QtCore.QSettings(QtCore.QSettings.IniFormat, QtCore.QSettings.UserScope,settingOrg, settingApp)

# maximum number of files in the recent file menu
MaxRecentFiles = 9

fileFilters = ["All Supported Files (*.po *.pot *.xlf *.xliff *.tmx *.tbx)", 
        "PO Files (*.po)",
        "PO Template Files (*.pot)",
        "XLIFF Files (*.xlf *.xliff)",
        "Translation Memory eXchange (TMX) Files (*.tmx)",
        "TermBase eXchange (TBX) Files (*.tbx)",
        "All Files (*)"]

fileFiltersGlossary = ["All Supported Files (*.po *.xlf *.xliff *.tbx)", 
        "PO Files (*.po)",
        "XLIFF Files (*.xlf *.xliff)",
        "TermBase eXchange (TBX) Files (*.tbx)",    
        "All Files (*)"]
        
fileFiltersTM = ["All Supported Files (*.po *.xlf *.xliff *.tmx)", 
        "PO Files (*.po)",
        "XLIFF Files (*.xlf *.xliff)",
        "Translation Memory eXchange (TMX) Files (*.tmx)",
        "All Files (*)"]
        
fileFiltersXLIFF = ["XLIFF Files (*.xlf *.xliff )", 
        "All Files (*)"]

fileFiltersSaveAs = ["All Supported Files (*.xlf *.xliff *.po)", 
        "XLIFF Files (*.xlf *.xliff )", 
        "PO Files (*.po)",
        "All Files (*)"]

# Project mode
projectModeNew = 1
projectModeOpen = 2
projectModeProperty = 3
projectModeDelete = 4

# Setting mode
settingModeTM = "TM"
settingModeGlossary = "Glossary"

# Spellcheck translations
wholeFile = 1
currentToFirst = 2
currentToLast = 4
checkFuzzy = True

# delimiter for bookmark
delimiter = " : "

dict_languages = {
#here description for Bengali dictionary is added to show the description in the dictionary list of Preference->Spellcheck
'Afrikaans (South Africa)' : ['af','ZA','af_ZA'],
'Akan (Ghana)' : ['ak','GH','ak_GH'],
'Amharic (Ethiopia)' : ['am'],
'Bengali (Bangladesh)' : ['bn','BD','bn_BD'],
'Bulgarian (Bulgaria)' : ['bg','BG','bg_BG'],
'Catalan (Spain)' : ['ca','ES','ca_ES'],
'Chinese (China)' : ['zh','CN','zh_CN'],
'Chinese (Hong Kong)' : ['zh','HK','zh_HK'],
'Chinese (Taiwan)' : ['zh','TW','zh_TW'],
'Croatian (Croatia)' : ['hr','HR','hr_HR'],
'Czech (Czech Republic)' : ['cs','CZ','cs_CZ'],
'Danish (Denmark)' : ['da','DK','da_DK'],
'Dutch (Netherlands)' : ['nl','NL','nl_NL'],
'English (United States)' : ['en','US','en_US'],
'English (Australia)' : ['en','AU','en_AU'],
'English (Canada)' : ['en','CA','en_CA'],
'English (New Zealand)' : ['en','NZ','en_NZ'],
'English (South Africa)' : ['en','ZA','en_ZA'],
'English (United Kingdom)' : ['en','GB','en_GB'],
'Esperanto (Anywhere)' : ['eo','ANY','eo_l3'], 
'Estonian (Estonia)' : ['et','EE','et_EE'],
'Faroese (Faroe Islands)' : ['fo','FO','fo_FO'],
'French (France)' : ['fr','FR','fr_FR'],
'French (Belgium)' : ['fr','BE','fr_BE'],
'Frisian (Netherlands)' : ['fy','NL','fy_NL'], 
'Galician (Spain)' : ['gl','ES','gl_ES'],
'Gascon (France)' : ['gsc','FR','gsc_FR'],
'German (Germany)' : ['de','DE','de_DE'],
'German (Austria)' : ['de','AT','de_DE'], 
'German (Liechtenstein)' : ['de','LI','de_CH'], 
'German (Luxembourg)' : ['de','LU','de_DE'],
'German (Switzerland)' : ['de','CH','de_CH'],
'Greek (Greece)' : ['el','GR','el_GR'],
'Gujarati (India)' : ['gu','IN','gu_IN'],
'Hebrew (Israel)' : ['he','IL','he_IL'],
'Hindi (India)' : ['hi','IN','hi_IN'],
'Hungarian (Hungary)' : ['hu','HU','hu_HU'],
'Icelandic (Iceland)' : ['is','IS','is_IS'],
'Indonesian (Indonesia)' : ['id','ID','id_ID'],
'Interlingua (ANY locale)' : ['ia','ANY','ia_ANY'],
'Irish (Ireland)' : ['ga','IE','ga_IE'],
'Italian (Italy)' : ['it','IT','it_IT'],
'Interlingua (x-register)' : ['ia'],
'Kashubian (Poland)' : ['csb'],
'Italian (Switzerland)' : ['it','CH','it_IT'],
'Khmer (Cambodia)' : ['km','KH','km_KH'],
'Kinyarwanda (Rwanda)' : ['rw','RW','rw_RW'],
'Kiswahili (East Africa)' : ['sw','KE','sw_KE'],
'Kurdish (Turkey)' : ['ku','TR','ku_TR'],
'Kurdish (Syria)' : ['ku','TR','ku_TR'],
'Latin (for x-register)' : ['it','IT','la'],
'Latvian (Latvia)' : ['lv','LV','lv_LV'],
'Lithuanian (Lithuania)' : ['lt','LT','lt_LT'],
'Luxembourgish (Luxembourg)' : ['lb','LU','lb_LU'],
'Macedonian (Macedonia)' : ['mk','MK','mk_MK'],
'Malagasy (Madagascar)' : ['mg','MG','mg_MG'],
'Malay (Malaysia)' : ['ms','MY','ms_MY'],
'Maori (New Zealand)' : ['mi','NZ','mi_NZ'],
'Marathi (India)' : ['mr','IN','mr_IN'],
'Mongolian (Mongolia)' : ['mn'],
'Mòoré (Burkina Faso)' : ['mos','BF','ms_BF'],
'Ndebele (South Africa)' : ['nr','ZA','nr_ZA'],
'Nepali (Nepal)' : ['ne','NP','ne_NP'],
'Northern Sotho (South Africa)' : ['ns','ZA','ns_ZA'], 
'Norwegian Bokmaal (Norway)' : ['nb','NO','nb_NO'], 
'Norwegian Nynorsk (Norway)' : ['nn','NO','nn_NO'],
'Occitan (Languedoc)' : ['oc','FR','oc_FR'],
'Oriya (India)' : ['or'],
'Persian (Iran)' : ['fa','IR','fa_IR'],
'Polish (Poland)' : ['pl','PL','pl_PL'],
'Portuguese (Portugal)' : ['pt','PT','pt_PT'],
'Portuguese (Brazil)' : ['pt','BR','pt_BR'],
'Punjabi (India)' : ['pa'],
'Quechua (Bolivia)' : ['qu','BO','qu_BO'],
'Romanian (Romania)' : ['ro','RO','ro_RO'],
'Russian (Russia)' : ['ru','RU','ru_RU'],
'Russian_ye (Russia)' : ['ru','RU','ru_RU_ye'],
'Russian_yo (Russia)' : ['ru','RU','ru_RU_yo'],
'Scottish Gaelic (Scotland)' : ['gd','GB','gd_GB'],
'Serbian (Serbia, Republic Srpska)' : ['sr','CS','sr_CS'],
'Setswana (Africa)' : ['tn','ZA','tn_ZA'],
'Slovak (Slovakia)' : ['sk','SK','sk_SK'],
'Slovenian (Slovenia)' : ['sl','SI','sl_SI'],
'Southern Sotho (South Africa)' : ['st','ZA','st_ZA'],
'Spanish (Spain)' : ['es','ES','es_ES'],
'Spanish (Mexico)' : ['es','MX','es_MX'],
'Swazi/Swati (South Africa)' : ['ss','ZA','ss_ZA'],
'Swedish (Sweden)' : ['sv','SE','sv_SE'],
'Tagalog (Philippines)' : ['tl','PH','tl_PH'],
'Tamil (India)' : ['ta'],
'Tetum (Indonesia)' : ['tet','D','tet_ID'],
'Thai (Thailand)' : ['th','TH','th_TH'],
'Tsonga (South Africa)' : ['ts','ZA','ts_ZA'],
'Ukrainian (Ukraine)' : ['uk','UA','uk_UA'],
'Urdu (Pakistan)' : ['ur','PK','ur_PK'],
'Uzbek (Uzbekistan)' : ['uz'],
'Venda (South Africa)' : ['ve','ZA','ve_ZA'],
'Vietnamese (Vietnam)' : ['vi','VN','vi_VN'],
'Welsh (Wales)' : ['cy','GB','cy_GB'],
'Xhosa (South Africa)' : ['xh','ZA','xh_ZA'],
'Zulu (South Africa)' : ['zu','ZA','zu_ZA']
}

dictionary_url = "http://wiki.services.openoffice.org/wiki/Dictionaries"

# 8203 is zwsp
SpellCheckIgniteKey = [QtCore.Qt.Key_Space, QtCore.Qt.Key_Return, QtCore.Qt.Key_Enter, QtCore.Qt.Key_Home, QtCore.Qt.Key_End, 8203]

# file dialog type
inputType = 1
outputType = 2
templateType = 4
tmType = 8

# file dialog mode
openMode = "open"
saveMode = "save"

#dir and log file
configDir, tail = os.path.split(unicode(settings.fileName()))
#logDir = "."+"wordforge"
logFile= os.path.join(configDir, "WordForge.log")

# options for gui converter
# TODO: make an XML file for it if possible

oo2xliff = "OpenOffice SDF format to XLIFF format"
xliff2oo = "XLIFF format to Openoffice SDF format"

xliff2po =  "XLIFF Format to PO or POT Format"
po2xliff = "PO or POT Format to XLIFF Format"

xliff2moodle = "XLIFF Format to Moodle PHP Format"
moodle2xliff = "Moodle PHP Format to XLIFF Format"

oo2po ="OpenOffice SDF format to PO format"
po2oo = "PO format to Openoffice SDF format"

csv2po = "CSV Format to PO or POT Format"
po2csv = "PO or POT Format to CSV Format"

dtd2po = "Mozilla DTD Format to PO Format"
po2dtd = "PO Format to Mozilla DTD Format"

html2po = "HTML File Format to PO or POT Format"
po2html = "PO or POT Format to HTML format"

po2nb = "PO Format to Nanoblogger HTML Format"
nb2po = "Nanoblogger HTML Format to PO Format"

po2moz = "PO or POT Format to Mozilla DTD and Properties Format"
moz2po = "Mozilla DTD and Properties Format to PO or POT Format"

po2pro = "PO or POT Format to Java/Mozilla .properties"
prop2po = "Java/Mozilla .properties to PO or POT Format"

ts2po = "Qt Linguist (.ts) Format to PO or POT Format"
po2ts = ".PO or POT Format to Qt Linguist (.ts) Format"

txt2po = "Plain Text TXT Format to PO or POT Format"
po2txt = "PO or POT Format to Plain Text TXT Format"

po2tmx = "PO or POT Format to  TMX (Translation Memory eXchange) Format"
pot2po = "POT Format to PO Format"
sxw2po = "OpenOffice Writer SXW Format to PO or POT Format"
csv2tbx = "CSV Format to TermBase eXchange TBX Format"
#goutom
odf2xliff="OpenDocument Format (ODF) to XLIFF format"
xliff2odf="XLIFF format to OpenDocument Format (ODF)"
#goutom
xliffupdate = "Update XLIFF Files, obtaining translation from old XLIFF files"

# converter lists: the page options order according to this list
converters = [oo2xliff, xliff2oo, xliff2po, po2xliff, xliff2moodle, moodle2xliff, xliffupdate, oo2po, po2oo,dtd2po,po2dtd, html2po, po2html,po2nb, nb2po ,po2moz,moz2po, csv2po, po2csv , po2pro,prop2po,ts2po,po2ts,txt2po, po2txt, po2tmx, pot2po, sxw2po, csv2tbx, odf2xliff, xliff2odf] 

# dictionary for save as
saveasdic = {"xlf2po":"WF_xliff2po", "xliff2po":"WF_xliff2po", \
                "po2xlf":"WF_po2xliff", "po2xliff":"WF_po2xliff"}

# dictionary of converters which are going to be used as subprocess        
converterdic = {odf2xliff:"WF_odf2xliff",xliff2odf:"WF_xliff2odf",  csv2po:"WF_csv2po", csv2tbx:"WF_csv2tbx", dtd2po:"WF_dtd2po", html2po:"WF_html2po", moodle2xliff:"WF_moodle2xliff", moz2po:"WF_moz2po", nb2po:"WF_nb2po", oo2po:"WF_oo2po", oo2xliff:"WF_oo2xliff", po2csv:"WF_po2csv", po2dtd:"WF_po2dtd", po2html:"WF_po2html", po2moz:"WF_po2moz", po2nb:"WF_po2nb", po2oo:"WF_po2oo", po2pro:"WF_po2prop", po2tmx:"WF_po2tmx", po2ts:"WF_po2ts", po2txt:"WF_po2txt", po2xliff:"WF_po2xliff", pot2po:"WF_pot2po", prop2po:"WF_prop2po", sxw2po:"WF_sxw2po", ts2po:"WF_ts2po", txt2po:"WF_txt2po",xliff2moodle:"WF_xliff2moodle", xliff2oo:"WF_xliff2oo", xliff2po:"WF_xliff2po",  xliffupdate:"WF_xliffupdate"} 

# file filter key for open (input) file dialog
inputFilterDic = {csv2po:["csv"], csv2tbx:["csv"], dtd2po: ["dtd"], html2po:["html"], moodle2xliff:["php"], moz2po:["moz2poInput"], nb2po:["html"], oo2po:["oo"], oo2xliff:["oo"], po2csv: ["po"], po2dtd: ["po"], po2html:["po"], po2moz:["moz2poOutput"], po2nb: ["po"], po2oo:["po"], po2pro:["po"], po2tmx:["po"], po2ts:["po"], po2txt:["po"], po2xliff:["po"], pot2po:["pot"], prop2po:["properties"], sxw2po:["sxw"], ts2po:["ts"], txt2po:["txt"],xliff2moodle:["xliff"], xliff2oo:["xliff", "po"], xliff2po:["xliff"], xliffupdate:["xliff"], odf2xliff:["odt", "ods", "odp", "odg", "odc", "odm", "odi", "ott", "ots", "otp", "otc", "otg", "otf", "oti", "oth", "odf", "sxw"], xliff2odf:["xliff"]}

# file filter key for save (output) file dialog
outputFilterDic = {csv2po: ["po"], csv2tbx:["tbx"], dtd2po: ["po"], html2po:["po"], moodle2xliff:["xliff"], moz2po:["moz2poOutput"], nb2po:["po"], oo2po:["po"], oo2xliff:["xliff"], po2csv: ["csv"], po2dtd:["dtd"], po2html:["html"], po2moz:["moz2poInput"], po2nb:["html"], po2oo:["oo"], po2pro:["properties"], po2tmx:["tmx"], po2ts:["ts"], po2txt:["txt"], po2xliff:["xliff"], pot2po:["po"], prop2po:["po"], sxw2po:["po"], ts2po:["po"], txt2po:["po"], xliff2moodle:["php"], xliff2oo:["oo"], xliff2po:["po"], xliffupdate:["xliff"],  odf2xliff:["xliff"],  xliff2odf:["odt", "ods", "odp", "odg", "odc", "odm", "odi", "ott", "ots", "otp", "otc", "otg", "otf", "oti", "oth", "odf", "sxw"]}

# file filter key for open (template) file dialog)
templatedic =  {csv2po:["po"], csv2tbx:[], dtd2po:["dtd"], html2po:[], moodle2xliff:["php"], moz2po:["moz2poInput"], nb2po:[], oo2po:[], oo2xliff:[], po2csv: [], po2dtd : ["dtd"], po2html:["html"], po2moz:["moz2poInput"], po2nb:["html"], po2oo:["oo"], po2pro:["properties"], po2tmx:[], po2ts:["ts"], po2txt:["txt"], po2xliff:["xliff"], pot2po:["po"], prop2po:["properties"], sxw2po:[], ts2po:[], txt2po:[],  xliff2moodle:["php"], xliff2oo:["oo"], xliff2po:["xliff"], xliffupdate:["xliff"], odf2xliff:[], xliff2odf:["odt", "ods", "odp", "odg", "odc", "odm", "odi", "ott", "ots", "otp", "otc", "otg", "otf", "oti", "oth", "odf", "sxw"]}

# file filter for input, output, template, exclude dialog
fileFilter = {"po": "PO or POT Template Files (*.po *.pot)", "pot": "PO Template Files (*.pot)", "dtd": "Mozilla UTF-8 localization format (*.dtd)", "xliff":"XLIFF Files (*.xlf)","tmx":"Translation Memory eXchange Files (*.tmx)","tbx":"TermBase eXchange (TBX) Files (*.tbx)","csv":"comma-separated values files (*.csv)", "html":"Hypertext Markup Language files(*.html *.htm *.xhtml)", "php":"PHP Files (*.php)", "moz2poInput": "mozilla files (*.dtd *.it *.xhtml *.ini *.manifest *.rdf *.html *.inc *.js *.properties)", "prop":"Properties files (*.prop)", "nb":"Properties files (*.prop)","oo":"OpenOffice.orge files (*.sdf)", "ts":"Translation files (*.ts)","moz2poOutput": "Mozilla Files to PO Files (*.it.po *.it.pot *.xhtml.po *.xhtml.pot *.ini.po *.ini.pot *.manifest *.rdf *.html.po *.html.pot *.inc.po *.inc.pot *.js *.dtd.po *.dtd.pot *.properties.po *.properties.pot)","properties":"Properties Files (*.properties)", "txt":"Text Files (*.txt)", "sxw":"OpenOffice Writer files (*.odt *.sxw)",  "xliffpo": "PO, POT Template or XLIFF Files (*.po *.pot *.xlf ).", "odt":"OpenDocument Text Document Files (*.odt)", "ods":"OpenDocument Spreadsheet Files (*.ods)", "odp":"OpenDocument Presentation Files (*.odp)", "odg":"OpenDocument Graphic File (*.odg)", "odc":"Office Data Connection File (*.odc)", "odf":"OpenDocument Formula Files (*.odf)", "odi":"OpenDocument Image Files (*.odi)", "odm":"OpenDocument Master Document Files (*.odm)", "ott":"OpenDocument Text Document Template Files (*.ott)", "ots":"OpenDocument Spreadsheet Template Files (*.ots)","otp":"OpenDocument Spreadsheet Template Files (*.otp)","otg":"OpenDocument Graphic Template Files (*.otg)", "otc":"OpenDocument Chart Template Files (*.otc)", "otf":"OpenType Font Files (*.otf)", "oti":"OpenDocument Image Template Files (*.oti)",  "oth":"OpenDocument HTML Template Files (*.oth)"}

tm = {pot2po:["po"]}

helpOption = ' --help '
inputOption = ' -i '
outputOption = ' -o '
templateOption = ' -t '
excludeFileOption = ' -x'
errorLevelOption = ' --errorlevel=message'
psycoOption = ' --psyco='
columnOrderOption = ' --columnorder='
duplicateOption = ' --duplicates='
charsetOption = ' --charset='
potOption = ' --Pot'
untaggedOption = ' --untagged'
languageOption = ' --language='
sourceLanguageOption = ' --source-language='
multiFile = ' --multifile='
nonRecursiveInput = ' --nonrecursiveinput'
noFuzzyOption = ' --nofuzzy'
fuzzyOption = ' --fuzzy'
wrapOption = ' --wrap='
localOption = ' --locale='
closeXpiOption = ' --clonexpi=CLONEXPI'
filerActionOptioni = ' --filteraction='
nonRecursiveTemplateOption = ' --nonrecursivetemplate'
nonRecursiveOutputOption = ' --nonrecursiveoutput'
keepTimeStampOption = ' --keeptimestamp'
filerActionOption = ' --filteraction='
encodingOption = ' --encoding='
flavourOption = ' --flavour='
personalityOption = ' --personality'
similarityOption = ' --similarity='
tmOption = ' --tm='
noFuzzyMatching =  ' --nofuzzymatching'


allFile = " All Files (*)"
workingDir = "workingDir"
logFileOption = "log.txt"
charsetDefaultOption = "default"
#list of unicode nonprinting characters category 
catsCrl=['Cn','Cc', 'Zs', 'Zl', 'Zp', 'L', 'R', 'Pd']

dict_nonprintable = {
#here description for Bengali dictionary is added to show the description in the dictionary list of Preference->Spellcheck
9 : 'TAB',
32 : 'SPACE',
160 : 'NO-BREAK SPACE',
8192 : 'EN QUAD',
8193 : 'EM QUAD',
8194 : 'EN SPACE',
8195 : 'EM SPACE',
8196 : 'THREE-PER-EM SPACE',
8197 : 'FOUR-PER-EM SPACE',
8198 : 'SIX-PER-EM SPACE',
8199 : 'FIGURE SPACE',
8200 : 'PUNCTUATION SPACE',
8201 : 'Thin Space',
8202 : 'Hair Space',	
8203 : 'ZERO WIDTH SPACE(ZWSP)',
8204 : 'Zero Width Non Joiner (ZWNJ)',
8205 : 'Zero Width Joiner (ZWJ)',
10: 'New Line'
}

lst_invisibleSpecial=['∙','→', '¶', '\u0009', '\u0020', '\u00A0', '\u2000', '\u2001', '\u2002', '\u2003', '\u2004', '\u2005', '\u2006', '\u2007', '\u2008', '\u2009', '\u200A', '\u200C', '\u200D', '\u2424']

dict_invisibleSpecial={
'TAB': ['→', '\u0009'],  
'SPACE': ['∙', '\u0020'],
'NO-BREAK SPACE': ['∙', '\u00A0'],
'EN QUAD':['∙', '\u2000'],
'EM QUAD': ['∙', '\u2001'],
'EN SPACE': ['∙', '\u2002'],
'EM SPACE': ['∙', '\u2003'],
'THREE-PER-EM SPACE': ['∙', '\u2004'],
'FOUR-PER-EM SPACE': ['∙', '\u2005'],
'SIX-PER-EM SPACE': ['∙', '\u2006'],
'FIGURE SPACE': ['∙', '\u2007'],
'PUNCTUATION SPACE': ['∙', '\u2008'],
'Thin Space':['∙', '\u2009'],
'Hair Space': ['∙', '\u200A'],
'Zero Width Space (ZWSP)':['∙', '\u200B'],
'Zero Width Non Joiner (ZWNJ)': ['∙', '\u200C'],
'Zero Width Joiner (ZWJ)': ['∙', '\u200D'], 
'New Line':['¶', '\u2424']
}

#list of regular characters that need to be replaced by back slash in glossary expression
regularExpressionCharacters = ['\\','.', '^', '$', '*', '+', '?','[',']','{', '}', '(', ')', '/', '&', '!', '@', '#', '%','|','\'','~',':' ]

#list of regular characters that need to be replaced by back slash in glossary expression
regularExpressionCharacters = ['\\','.', '^', '$', '*', '+', '?','[',']','{', '}', '(', ')', '/', '&', '!', '@', '#', '%','|','\'','~',':']
#For use in errorchecking we are writing some application specific variable start and end marker.
openOfficeVarmatches = [("&", ";"), ("%", "%"), ("%", None), ("%", 0), ("$(", ")"), ("$", "$"), ("${", "}"), ("#", "#"), ("#", 1), ("#", 0), ("($", ")"), ("$[", "]"), ("[", "]"), ("$", None)]
mozillaVarmatches = [("&", ";"), ("%", "%"), ("%", 1), ("$", "$"), ("$", None), ("#", 1), ("${", "}"), ("$(^", ")")]
kdeVarmatches = [("%", 1)]
drupalVarmatches = [("%", None), ("@", None)]
